##    perl2dvd.pl - Multi-purpuse video conversion tool
##    Copyright (C) 2006    Scott Zadigian  zadigian(at)gmail(dot)com
##
##    This program is free software; you can redistribute it and/or modify
##    it under the terms of the GNU General Public License as published by
##    the Free Software Foundation; either version 2 of the License, or
##    (at your option) any later version.
##
##    This program is distributed in the hope that it will be useful,
##    but WITHOUT ANY WARRANTY; without even the implied warranty of
##    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##    GNU General Public License for more details.
##
##    You should have received a copy of the GNU General Public License
##    along with this program; if not, write to the Free Software
##    Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
##    02111-1307, USA
##---------------------------------------------------------------------------##

#! /user/bin/perl
#

use Win32::Shortcut;

if (@ARGV == 0)
{
    print "\nInvalid parameters\n\n";
    print "\tusage: perl2dvd.exe <QDVD_FILE> <PATH_TO_PERL2DVD.PREF>\n";
    print "\tor   : perl2dvd.exe <PATH_TO_MPEG> <ENCODING_PROFILE> <PATH_TO_SAGE_DIR>\n\n\n";
    die;
}

# Create log file
$logFile = "$ARGV[0].dvd.log";
open( LOGFILE, ">$logFile" ) || die "Can't open create log file";
select(LOGFILE);

# Get Preferences
unless ( open( PREFS, "$ARGV[1]" ) )
{
    unless ( open( PREFS, "perl2dvd.pref" ) )
    {
        unless ( open( PREFS, "$ARGV[2]\\perl2dvd.pref" ) )
        {
            print "Can't open Preference File\n";
            die "Can't open Preference File";
        }
    }
}
srand;

#Get the current Date
@f = (localtime)[ 3 .. 5 ];                                          # grabs day/month/year values
$startDate = ( $f[1] + 1 ) . "-" . $f[0] . "-" . ( $f[2] + 1900 );
( $sec, $min, $hr ) = localtime();
$startTime = "$hr:$min:$sec";
print "Welcome to perl2dvd v2.0a\n";
print "Staring Proccesing at $startTime $startDate\n";

$compressMode = 0;
if ( @ARGV == 3 )
{   # Special case for compression
    $compressMode = 1;
    print "Staring in easy compress mode\n";
    print "File    : $ARGV[0]\n";
    print "Profile : $ARGV[1]\n";
    print "Sagedir : $ARGV[2]\n\n";
}
else
{
    print "Staring in regular mode\n";
    print "qdvd File : $ARGV[0]\n";
    print "pref File : $ARGV[1]\n";

    if (!($ARGV[0] =~ /\.qdvd/))
    {
        print "Invalid qdvd File!\n";
        die;
    }
}

print "\n------------------Basic Preferences--------------------\n";
while ( !( <PREFS> =~ /perl2dvd pref/ ) )
{
    print "$_";
}
<PREFS> =~ /=/;
print "Sage Directory = $'";
$sageDir = $';
chomp($sageDir);

# If we're in easy mode
if ( $compressMode == 1 )
{
    $sageDir = @ARGV[2];
    print "+ Easy Compress Sage Direcotry = $sageDir\n";
}

<PREFS> =~ /=/;
print "imgBurn = $'";
$imgBurn = $';
chomp($imgBurn);

<PREFS> =~ /=/;
print "sageOthers = $'";
$sageOthers = $';
chomp($sageOthers);

<PREFS> =~ /=/;
print "localSageOthers = $'";
$localSageOthers = $';
chomp($localSageOthers);

<PREFS> =~ /=/;
print "burnerDrive = $'";
$burnerDrive = $';
chomp($burnerDrive);

<PREFS> =~ /=/;
$theme = $';
chomp($theme);
print "DVD Menu theme = $theme\n";

<PREFS> =~ /=/;
print "scratchPath = $'";
$scratchPath = $';
chomp($scratchPath);

while ( !( <PREFS> =~ /add2DVDQ pref/ ) )
{

    #print "$_\n";
}

<PREFS> =~ /=/;
print "qdvd folder = $'";
$qdvdFolder = $';
chomp($qdvdFolder);

close(PREFS);

#Get Advanced Preferences
print "\n------------------Advanced Preferences--------------------\n";
$ARGV[1] =~ m#[^\\/]*\.pref$#;

if ( !open( PREFS, "$`perl2dvd.advanced.pref" ) )
{
    if ( !open( PREFS, "perl2dvd.advanced.pref" ) )
    {
        unless ( open( PREFS, "$ARGV[2]\\perl2dvd.advanced.pref" ) )
        {
            print "Can't open Advanced Preference File\n";
            die "Can't open Advanced Preference File";
        }
    }
}

$advancedPrefsFound = 0;
$expectedAdvPrefs = 39;

# Defaults for aditions
$thumbnailEffect = "slide";
$centralWorkFolder = "";

while(<PREFS>)
{
    $line = $_;
    chomp($line);

    if ($line =~ /HDTV switches for ffmpeg/)
    {
        $line =~ /=/;
        $ffmpegSwitchesHDTV = $';
        chomp($ffmpegSwitchesHDTV);
        print "ffmpegSwitchesHDTV = $ffmpegSwitchesHDTV\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Regular switches for ffmpeg/)
    {
        $line =~ /=/;
        $ffmpegSwitches = $';
        chomp($ffmpegSwitches);
        print "ffmpegSwitches = $ffmpegSwitches\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Maximum Bitrate/)
    {
        $line =~ /=/;
        $maxBitrate = $';
        chomp($maxBitrate);
        print "maxBitrate = $maxBitrate\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /DVD format/)
    {
        $line =~ /=/;
        $dvdRes = $';
        chomp($dvdRes);
        print "DVD Res = $dvdRes\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /ImgBurn Switches/)
    {
        $line =~ /=/;
        $imgBurnSwitches = $';
        chomp($imgBurnSwitches);
        print "imgBurnSwitches = $imgBurnSwitches\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Image to show in "Other Programs" menu/)
    {
        $line =~ /=/;
        $burnImage = $';
        chomp($burnImage);
        print "burnImage = $burnImage\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Target DVD Size in billion bytes/)
    {
        $line =~ /=/;
        $targetSize = $';
        chomp($targetSize);
        print "TargetSize = $targetSize Billion Bytes \n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Number of seconds to pad comskip for HDTV files/)
    {
        $line =~ /=/;
        $HDTVcomskipOffset = $';
        chomp($HDTVcomskipOffset);
        print "HDTV comskipOffset = $HDTVcomskipOffset Seconds\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Number of seconds to pad comskip for SDTV files/)
    {
        $line =~ /=/;
        $SDTVcomskipOffset = $';
        chomp($SDTVcomskipOffset);
        print "SDTV comskipOffset = $SDTVcomskipOffset Seconds\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Default Chapter Length in minutes if no comskip file exists/)
    {
        $line =~ /=/;
        $defaultChap = $';
        chomp($defaultChap);
        $defaultChap = sprintf( "%d", $defaultChap );
        if ( $defaultChap == 0 )
        {
            $defaultChap = 1000;
        }
        print "Defualt Chapter Length = $defaultChap\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /MPEG bitrate correction coefs/)
    {
        $line =~ /=/;
        $hdtvBitrateAdjustment = $';
        chomp($hdtvBitrateAdjustment);
        print "MPEG Bitrate Adjustment coefs = $hdtvBitrateAdjustment \n";
        @hdtvAdjustmentCoefs = split( /,/, $hdtvBitrateAdjustment );
        $advancedPrefsFound++;
    }

    if ($line =~ /AVI bitrate correction coefs/)
    {
        $line =~ /=/;
        $aviBitrateAdjustment = $';
        chomp($aviBitrateAdjustment);
        print "non-MPEG Bitrate Adjustment coefs = $aviBitrateAdjustment \n";
        @aviAdjustmentCoefs = split( /,/, $aviBitrateAdjustment );
        $advancedPrefsFound++;
    }

    if ($line =~ /AVI Title and Episode RegE/)
    {
        $line =~ /=/;
        $aviInfoRegEx = $';
        chomp($aviInfoRegEx);
        print "non-MPEG file info regEX = $aviInfoRegEx\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Transcoding priority/)
    {
        $line =~ /=/;
        $transcodePriority = $';
        chomp($transcodePriority);
        # if not valid default to belownormal
        if (!($transcodePriority =~ /(low|normal|high|realtime|abovenormal|belownormal)/))
        {
            $transcodePriority = "belownormal";
        }
        print "Transcode Priority = $transcodePriority\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Optional UNC path to work folder to used for buring/)
    {
        $line =~ /=/;
        $uncWorkFolder = $';
        chomp($uncWorkFolder);
        print "Optional UNC version of work folder to use for burning .bat file = $uncWorkFolder\n";
        if ($uncWorkFolder =~ /,/)
        {
            @fullToUNCIMG = split( /,/, $uncWorkFolder );
        }
        $advancedPrefsFound++;
    }

    if ($line =~ /Optional path to SageTV or SageTVClient/)
    {
        $line =~ /=/;
        $sageReWake = $';
        chomp($sageReWake);
        print "Optional path to SageTV or SageClient executable relative burning computer for .bat file = $sageReWake\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Enable creation of status images/)
    {
        $line =~ /=/;
        $enableStatus = $';
        chomp($enableStatus);
        print "Enable Updating Status Pictures in Other Programs menu = $enableStatus\n";

        if ( $compressMode == 1 )
        {
            $enableStatus = 0;
            print "+ Easy Compress force diable enable Status pictures = $enableStatus\n";
        }
        $advancedPrefsFound++;
    }

    if ($line =~ /New demux check correction/)
    {
        $line =~ /=/;
        $demuxCorrection = $';
        chomp($demuxCorrection);
        print "New demux check correction = $demuxCorrection\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Optional other programs special extension/)
    {
        $line =~ /=/;
        $otherProgramsExt = $';
        chomp($otherProgramsExt);
        if ( !( $otherProgramsExt =~ /(_m|_x)/ ) )
        {
            $otherProgramsExt = "";
        }
        print "Optional other programs special extention = $otherProgramsExt\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Change image permissions to enable deleting over network/)
    {
        $line =~ /=/;
        $changeImgPermissions = $';
        chomp($changeImgPermissions);
        print "Change Image permissions = $changeImgPermissions\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Create runnable batch files in add2dvdq to enable dirmon-less operation/)
    {
        $line =~ /=/;
        $createBatchFile = $';
        chomp($createBatchFile);
        print "Create runable batch file in add2dvdq = $createBatchFile\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Disable creating readable names in add2dvdq/)
    {
        $line =~ /=/;
        $disableReadable = $';
        chomp($disableReadable);
        print "Disable creating readable file names = $disableReadable \n";
        $advancedPrefsFound++;
    }

    if ($line =~ /RegEX to Strip out problem characters for file names/)
    {
        $line =~ /=/;
        $illCharFileRegEx = $';
        chomp($illCharFileRegEx);
        print "RegEX for stripping out illigal charactors in readable filename = $illCharFileRegEx \n";
        $advancedPrefsFound++;
    }

    if ($line =~ /RegEX to strip out problem characters for menu generation/)
    {
        $line =~ /=/;
        $illCharMenuRegEx = $';
        chomp($illCharMenuRegEx);
        print "RegEX for stripping out illigal charactors in menuGen = $illCharMenuRegEx \n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Translate full paths to UNC paths/)
    {
        $line =~ /=/;
        $translatePaths = $';
        chomp($translatePaths);
        print "Translate paths to UNC = $translatePaths\n";
        @fullToUNC = split( /,/, $translatePaths );
        $advancedPrefsFound++;
    }

    if ($line =~ /Default transcoding profile to use/)
    {
        $line =~ /=/;
        $defaultTransProfile = $';
        chomp($defaultTransProfile);
        print "Mencoder transcoding profile to use = $defaultTransProfile\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Files to save with compressed videos DVD/)
    {
        $line =~ /=/;
        $typesToSave = $';
        chomp($typesToSave);
        print "Mencoder File types to save with compressed videos= $typesToSave\n";
        @extsToSave = split( /,/, $typesToSave );
        $advancedPrefsFound++;
    }

    if ($line =~ /Auto delete originals after compress to DVD/)
    {
        $line =~ /=/;
        $autoDeleteXvidDVD = $';
        chomp($autoDeleteXvidDVD);
        print "Automatically delete compressed files when sent to DVD = $autoDeleteXvidDVD\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Auto delete originals after compress in place/)
    {
        $line =~ /=/;
        $autoDeleteVidLib = $';
        chomp($autoDeleteVidLib);
        print "Automatically delete compressed files when sent to Video Library = $autoDeleteVidLib\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /When compressing to data DVD also compress in place/)
    {
        $line =~ /=/;
        $inPlaceAndDVD = $';
        chomp($inPlaceAndDVD);
        print "Always do an in place replace when compressing to DVD = $inPlaceAndDVD\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Attempt to cut commercials when compressing/)
    {
        $line =~ /=/;
        $editCommercialsCompress = $';
        chomp($editCommercialsCompress);
        print "Try and edit out commercials when compressing videos = $editCommercialsCompress\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Attempt to cut commercials when making video DVD/)
    {
        $line =~ /=/;
        $editCommercialsDVD = $';
        chomp($editCommercialsDVD);
        print "Try and edit out commercials when making DVD's = $editCommercialsDVD\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Min time for first chapter on commercial cut DVD/)
    {
        $line =~ /=/;
        $firstChapterMinTime = $';
        chomp($firstChapterMinTime);
        print "Min time for first chapter on commercial cut DVD = $firstChapterMinTime\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Disable Creating Test DVD/)
    {
        $line =~ /=/;
        $disableTestDVD = $';
        chomp($disableTestDVD);
        print "Disable creating test DVD = $disableTestDVD\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Number of screenshots to take for submenus/)
    {
        $line =~ /=/;
        $numScreenShots = $';
        chomp($numScreenShots);
        print "Number of Screen shots to get = $numScreenShots\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Save extra files for debugging/)
    {
        $line =~ /=/;
        $debugDelete = $';
        chomp($debugDelete);
        print "Debug Mode = $debugDelete\n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Wait for edl file/)
    {
        $line =~ /=/;
        $waitForEdl = $';
        chomp($waitForEdl);
        print "If comskip log file exists, wait for edl file = $waitForEdl \n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Show finished status icon when finished with in place conversions/)
    {
        $line =~ /=/;
        $showFinished = $';
        chomp($showFinished);
        print "Show finished status icon when finished with in place conversions = $showFinished \n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Save Log File/)
    {
        $line =~ /=/;
        $saveLogFile = $';
        chomp($saveLogFile);
        print "Save Log File = $saveLogFile \n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Use specified work folder for all processing/)
    {
        $line =~ /=/;
        $centralWorkFolder = $';
        chomp($centralWorkFolder);
        print "Use specified work folder for all processing = $centralWorkFolder \n";
        $advancedPrefsFound++;
    }

    if ($line =~ /Thumbnail animation effect/)
    {
        $line =~ /=/;
        $thumbnailEffect = $';
        chomp($thumbnailEffect);
        print "Thumbnail animation effect = $thumbnailEffect \n";
        $advancedPrefsFound++;
    }

}
close(PREFS);

print "Found $advancedPrefsFound advanced preferences\n";
if ($advancedPrefsFound != $expectedAdvPrefs)
{
    print "Expected $expectedAdvPrefs, check your preference file!\n";
    die;
}

print "\n------------------Mencoder Profiles--------------------\n";
$ARGV[1] =~ m#[^\\/]*\.pref$#;

if ( !open( PREFS, "$`perl2dvd.mencoder.profiles" ) )
{
    if ( !open( PREFS, "perl2dvd.mencoder.profiles" ) )
    {
        unless ( open( PREFS, "$ARGV[2]\\perl2dvd.mencoder.profiles" ) )
        {
            print "Can't open mencoder profiles File\n";
            die "Can't open mencoder profiles File";
        }
    }
}

while (<PREFS>)
{
    chomp;
    if ( $_ =~ /Profile.*=/ )
    {
        @profile = ();

        # Profile Name
        $_ =~ /=/;
        $profiles[0] = $';

        # Default Command
        <PREFS> =~ /=/;
        $temp = $';
        chomp($temp);
        $_ =~ /=/;
        $profiles[1] = $temp;

        # Pass 1 Options
        <PREFS> =~ /=/;
        $temp = $';
        chomp($temp);
        $profiles[2] = $temp;

        # Pass 2 Options
        <PREFS> =~ /=/;
        $temp = $';
        chomp($temp);
        $profiles[3] = $temp;

        # Container
        <PREFS> =~ /=/;
        $temp = $';
        chomp($temp);
        $profiles[4] = $temp;

        # mb/30 minutes
        <PREFS> =~ /=/;
        $temp = $';
        chomp($temp);
        $profiles[5] = $temp;

        # Custom Resolutions
        <PREFS> =~ /=/;
        $temp = $';
        chomp($temp);
        $profiles[6] = $temp;

        # Audio Options
        <PREFS> =~ /=/;
        $temp = $';
        chomp($temp);
        $profiles[7] = $temp;

        # Copy AC3
        <PREFS> =~ /=/;
        $temp = $';
        chomp($temp);
        $profiles[8] = $temp;

        # Estimate Audio Size
        <PREFS> =~ /=/;
        $temp = $';
        chomp($temp);
        $profiles[9] = $temp;

        # Custom Video Filters
        <PREFS> =~ /=/;
        $temp = $';
        chomp($temp);
        $profiles[10] = $temp;

        push @mencoderProfiles, [@profiles];
    }
}

push @mencoderProfiles, [ ( "perl2DVD_default",
                            "xvid -xvidencopts",
                            "turbo:nochroma_me:notrellis:max_bframes=0:vhq=0:pass=1",
                            "vhq=2:bvhq=1:chroma_opt:quant_type=mpeg:pass=2:bitrate=",
                            "avi",
                            "250~1280::350~720::350",
                            "512",
                            "-oac mp3lame -lameopts vbr=3",
                            "1",
                            "0",
                            "" ) ];

for $profile (@mencoderProfiles)
{
    print "Profile \"@$profile[0]\":\n";
    print "\tdefault       : @$profile[1]\n";
    print "\tpass #1       : @$profile[2]\n";
    print "\tpass #2       : @$profile[3]\n";
    print "\tcontainer     : @$profile[4]\n";
    print "\tmb/30 min     : @$profile[5]\n";
    print "\tCustom Res    : @$profile[6]\n";
    print "\tAudio Opts    : @$profile[7]\n";
    print "\tCopy AC3      : @$profile[8]\n";
    print "\tEst. Aud Size : @$profile[9]\n";
    print "\tVideo Filters : @$profile[10]\n";

}
print "\n";

if (!($burnImage =~ /(jpg|png)/))
{
    $burnImage = "$sageDir\\perl2DVD\\burnImage.jpg";
}

$sageTVTranscoder = "$sageDir\\SageTVTranscoder.exe";
$ffmpeg           = "$sageDir\\perl2dvd\\ffmpeg.exe";
$dvdAuthor        = "$sageDir\\perl2DVD\\dvdauthor.exe";
$mkisofs          = "$sageDir\\perl2DVD\\mkisofs.exe";
$gm               = "$sageDir\\perl2DVD\\gm.exe";
$png2yuv          = "$sageDir\\perl2DVD\\png2yuv.exe";
$mpeg2enc         = "$sageDir\\perl2DVD\\mpeg2enc.exe";
$mplex            = "$sageDir\\perl2DVD\\mplex.exe";
$spumux           = "$sageDir\\perl2DVD\\spumux.exe";
$mpgtx            = "$sageDir\\perl2DVD\\mpgtx.exe";
$bbdmux           = "$sageDir\\perl2DVD\\bbdmux.exe";
$mencoder         = "$sageDir\\perl2DVD\\mencoder.exe";
$touch            = "$sageDir\\perl2DVD\\touch.exe";
print "ffmpeg           = $ffmpeg\n";
print "burnImage        = $burnImage\n";
print "dvdAuthor        = $dvdAuthor\n";
print "mkisofs          = $mkisofs\n";
print "grMagic          = $gm\n";
print "png2yuv          = $png2yuv\n";
print "mpeg2enc         = $mpeg2enc\n";
print "mplex            = $mplex\n";
print "spumux           = $spumux\n";
print "bbdmux           = $bbdmux \n";
print "mencoder         = $mencoder\n";
print "touch            = $touch \n";
print "SageTVTranscoder = $sageTVTranscoder \n";

# printing mencoder info
print "\n------------ Mencoder Version ----------------\n";
$mencoderString = "\"$mencoder\"";
$output = `$mencoderString`;
print $output;

# printing ffmpeg info
print "\n------------ FFmpeg Version ----------------\n";
$ffmpegString = "\"$ffmpeg\" -i in.mpg out.mpg 2> \"$sageDir\\perl2dvd\\ffmpeg.out\"";
`$ffmpegString`;
if ( open( FFMPEG, "$sageDir\\perl2dvd\\ffmpeg.out" ) )
{
    while(<FFMPEG>)
    {
        print $_;
    }
}
close(FFMPEG);
print "\n";

# printing ffmpeg info
print "\n------------ SageTVTranscoder Version ----------------\n";
$ffmpegString = "\"$sageTVTranscoder\" -i in.mpg out.mpg 2> \"$sageDir\\perl2dvd\\ffmpeg.out\"";
`$ffmpegString`;
if ( open( FFMPEG, "$sageDir\\perl2dvd\\ffmpeg.out" ) )
{
    while(<FFMPEG>)
    {
        print $_;
    }
}
close(FFMPEG);
print "\n";


# Get drive letter from SageDir
$sageDir =~ /[A-Za-z]:/;
$sageDrive = $&;
print "SageTV drive letter = $sageDrive\n";
print "\n";

# Get name of ffmpeg program
$ffmpeg =~ m#[^\\/]*\.exe$#;
$ffmpegEXE = $&;
print "ffmpeg Program = $ffmpegEXE\n";

# Get name of mencoder program
$mencoder =~ m#[^\\/]*\.exe$#;
$mencoderEXE = $&;
print "mencoder Program = $mencoderEXE\n";

# Get qdvd info
print "\n------------ Getting QDVD file info ----------------\n";
$qdvdFullPath = $ARGV[0];
chomp($qdvdFullPath);
$qdvdFullPath =~ s#/#\\#g;
print "QDVD Full Path = $qdvdFullPath\n";

# Get filename with extention
$qdvdFullPath =~ m#[^\\/]*\.(qdvd|mpg|mpeg|ts)$#;
$qdvdFileName = $&;
print "QDVD Filename  = $`($&)$'\n";

# Get filename w/o extention
$qdvdFileName =~ /\.(qdvd|mpg|mpeg|ts)/;
$qdvdFile = $`;
print "QDVD File      = ($`)$&$'\n";

# Get full path without extention
$qdvdFullPath =~ /\.(qdvd|mpg|mpeg|ts)/;
$qdvdFullFile = $`;
print "QDVD Full file = ($`)$&$'\n";


# Make an array of data that won't change to save some typing
@statusImageArray = ( "$sageOthers\\$qdvdFile.burn", $burnImage, $gm, "$sageDir\\perl2DVD", $enableStatus, "$localSageOthers\\$qdvdFile.burn", "$localSageOthers", "$sageReWake" );

# Place .work file to block dirmon from processing again
open( WORKFILE, ">$qdvdFullFile.work" );
print WORKFILE "Working\n";
close(WORKFILE);

if ( $qdvdFullFile =~ /xvidList/ )
{
    print "\n*&*&*&*&*&*&*&*& Setting mode to xvid DVD &*&*&*&*&*&*&&*&\n\n";
    $targetFormat = "xvid";
}
elsif ( $qdvdFullFile =~ /dvdList/ )
{
    print "\n*&*&*&*&*&*&*&*& Setting mode to video DVD &*&*&*&*&*&*&&*&\n\n";
    $targetFormat = "dvd";
}
elsif ( $qdvdFullFile =~ /vidLibList/ || $compressMode == 1 )
{
    print "\n*&*&*&*&*&*&*&*& Setting mode to xvid to Video Library &*&*&*&*&*&*&&*&\n\n";
    $targetFormat = "vidLib";
}
else
{
    updateStatusImage( "error", "qdvd file name, $qdvdFullFile, doesn't have valid type", @statusImageArray );
}

# Create Status Picture
if ( $enableStatus != 0 )
{
    updateStatusImage( "processing", "", @statusImageArray );
}

if ( $compressMode == 0 )
{
    print "\n------------ Checking for finished burns to delete ----------------\n";

    #Check for finished burns in $sageOthers folder
    unless ( opendir( CHECK, "$sageOthers" ) )
    {
        updateStatusImage( "error", "Can't open directory $sageOthers", @statusImageArray );
    }
    while ( $name = readdir(CHECK) )
    {
        if ( $name =~ /\.done/ )
        {
            print "deleteing $`\n";
            $toDelete = $sageOthers . "\\" . $`;
            print `del "$toDelete.done"`;
            print `del "$toDelete.bat"`;
            print "\n";
        }

    }
    close(CHECK);
}

@months   = qw(Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec);
@weekDays = qw(Sun Mon Tue Wed Thu Fri Sat Sun);

# Make subfolder to work in
print "\n------------ Generating work Paths ----------------\n";
$scratchPathIMG = $scratchPath;
print "Image Save Location = $scratchPathIMG\n";

if ( $dvdRes =~ /(pal|PAL)/ )
{
    $ffmpegTargetFormat = "pal-dvd";
    $dvdFrameRate       = "25";
    $dvdResolution      = "720x576";
    $regionalFormat     = "pal";
}
else
{
    $ffmpegTargetFormat = "ntsc-dvd";
    $dvdFrameRate       = "29.97";
    $dvdResolution      = "720x480";
    $regionalFormat     = "ntsc";
}

print "\n------------ Reading QDVD file ----------------";

#-------------- Video Info Loop ----------------
# Get video info from qdvd file

if ($compressMode == 0)
{    # if we have a qdvd file, open it
    unless ( open( QDVDFILE, "$ARGV[0]" ) )
    {
        updateStatusImage( "error", "Couldn't open qdvd File", @statusImageArray );
    }
}

$numberOfVideos = 0;
while( defined( $line = <QDVDFILE> ) || ( $compressMode == 1 && $numberOfVideos == 0 ) )
{
    if ( $line =~ /.*!!!.*@@@.*###.*\$\$\$.*%%%/ || $compressMode == 1)
    {
        # Reset abort
        $abort = 0;

        print "\n------------video Info Loop #$numberOfVideos ----------------\n";
        $videoIndex = $numberOfVideos;
        $numberOfVideos++;
        # Get Full path to video
        if ( $compressMode == 0 )
        {
            $qdvdLine = $line;
            chomp($qdvdLine);
            $qdvdLine =~ /!!!/;
            push( @fullPath, $` );
            chomp( $fullPath[$videoIndex] );
        }
        else
        {
            push( @fullPath, $ARGV[0] );
        }
        print "Full Path[$videoIndex] = $fullPath[$videoIndex]\n";

        # Get full path without extention
        $fullPath[$videoIndex] =~ /\.(mpeg|mpg|ts|avi)$/;
        push( @fullFile, $` );
        print "Full file[$videoIndex] = ($`)$&$'\n";

        if ( !(-e "$fullPath[$videoIndex]") && (-e "$fullFile[$videoIndex].compressed" && -e "$fullFile[$videoIndex].avi") )
        {   # Looking for original, found compressed.
            print "Original doesn't exist, but compressed does.  Using Compressed\n";
            $fullPath[$videoIndex] =  "$fullFile[$videoIndex].avi";
        }
        elsif ( !(-e "$fullPath[$videoIndex]") )
        {   # Orignal doesn't exist
            $abort = 1;
            $reason = "Video doesn't exist, stopping here";
        }


        if ( -e "$fullFile[$videoIndex].compressed" && $targetFormat =~ /vidLib/ )
        {   # Should already be compressed, so lets stop here
            $abort = 1;
            $reason = "Already compressed, stopping here";
        }

        if ( $abort != 0 )
        {   # Abort without reporting error
            print "$reason\n";
            close(QDVDFILE);
            if ($compressMode == 0)
            {
                print "del \"$qdvdFullPath\"\n";
                `del "$qdvdFullPath"`;
            }
            print "del \"$qdvdFullFile.work\"\n";
            `del "$qdvdFullFile.work"`;

            # Delete status images
            $delString = "del \"$sageOthers\\$qdvdFile.burn_i.lnk\"";
            print "Deleting fake shortcut: $delString\n";
            `$delString`;

            $delString = "del \"$sageOthers\\$qdvdFile.burn_i.jpg\"";
            print "Deleting status image: $delString\n";
            `$delString`;

            die;

        }


        if (!(-e "$fullFile[$videoIndex].edl")   && $fullPath[$videoIndex] =~ /\.(mpg|mpeg|ts)/ &&
             (($targetFormat  =~ /(xvid|vidLib)/ && $waitForEdl =~ /(1|3)/) ||
              ($targetFormat =~ /dvd/            && $waitForEdl =~ /(2|3)/)))
        {   # Waiting for comskip file
            print "Waiting for .edl file\n";
            close(QDVDFILE);
            print "del \"$qdvdFullFile.work\"\n";
            `del "$qdvdFullFile.work"`;

            # Reset status to queued
            $gmString = "\"$gm\" composite -resize 150x150 \"$sageDir\\perl2dvd\\queued.png\" \"$burnImage\" \"$sageOthers\\$qdvdFile.burn_i.jpg\"";
            print "Executing- $gmString\n";
            `$gmString`;

            die;
        }

        if ( !(-e "$fullPath[$videoIndex]") && (-e "$fullFile[$videoIndex].compressed" && -e "$fullFile[$videoIndex].avi") )
        {   # Looking for original, found compressed.
            print "Original doesn't exist, but compressed does.  Using Compressed\n";
            $fullPath[$videoIndex] =  "$fullFile[$videoIndex].avi";
        }

        foreach $path (@fullToUNC)
        {   # In case people are having trouble with mapped drives
            $path =~ /::/;
            $UNC  = $';
            $FULL = $`;
            chomp($UNC);
            chomp($FULL);
            if ( $fullPath[$videoIndex] =~ /\Q$FULL\E/ )
            {
                $fullPath[$videoIndex] = $UNC . $';
                print "Translating to UNC: $fullPath[$videoIndex]\n";
            }
        }

        # Get extention
        unless ( $fullPath[$videoIndex] =~ /\.(mpeg|mpg|ts|avi)/ )
        {
            updateStatusImage( "error", "Video type, $fullPath[$videoIndex], not supported", @statusImageArray );
        }
        push( @extention, $& );
        print "Extention[$videoIndex] = $`($&)$'\n";

        # Get filename with extention
        $fullPath[$videoIndex] =~ m#[^\\/]*\.(mpeg|mpg|ts|avi)$#;
        push( @pathToFile, $` );
        push( @fileName,   $& );
        print "Filename[$videoIndex]  = $`($&)$'\n";
        print "Path To File[$videoIndex] = ($`)$&$'\n";

        # Get filename w/o extention
        $fileName[$videoIndex] =~ /\.(mpeg|mpg|ts|avi)$/;
        push( @extentions, $& );
        push( @file,       $` );
        print "File[$videoIndex]      = ($`)$&$'\n";
        print "File Extention[$videoIndex] = $`($&)$'\n";
        if ($compressMode == 1)
        {
            $qdvdFile = $file[$videoIndex]
        }

        # This will break if we translate UNC paths, nothing we can do
        $fullPath[$videoIndex] =~ /(\\\\[a-zA-z0-9_ ]+|[a-zA-z]:)/;
        push( @fileDriveLetter, $& );
        print "File Drive Letter[$videoIndex] = $`($&)$'\n";

        if ( $centralWorkFolder eq "" )
        {
            $scratchPath[$videoIndex] = "$pathToFile[$videoIndex]"."$qdvdFile.WorkFolder";
        }
        else
        {
            $scratchPath[$videoIndex] = "$centralWorkFolder\\$qdvdFile.WorkFolder";
        }

        if ($videoIndex == 0 && $centralWorkFolder eq "")
        {    # Make the Img Path in the first recording directory
            $scratchPathIMG = $pathToFile[$videoIndex];
        }
        elsif ($videoIndex == 0 && !($centralWorkFolder eq ""))
        {
            $scratchPathIMG = "$centralWorkFolder\\";
        }

        print "Image Folder[$videoIndex] = $scratchPathIMG\n";
        print "Work Folder = $scratchPath[$videoIndex]\n";
        $mkdirString = "mkdir \"$scratchPath[$videoIndex]\"";
        if (!(-e "$scratchPath[$videoIndex]"))
        {   # If the folder doesn't exist, make it
            print "Making work directory: $mkdirString\n";
            `$mkdirString`;
        }

        # Pull out extra info
        if ( $compressMode == 0 )
        {
            if ( $fileName[$videoIndex] =~ /\.(mpeg|mpg|ts)$/ )
            {    # If it's a Sage Recording

                $qdvdLine =~ /@@@/;
                $temp = $';
                $temp =~ /###/;
                push( @showTitle, $` );
                print "showTitle[$videoIndex] = ($`)$&$'\n";

                $qdvdLine =~ /###/;
                $temp = $';
                $temp =~ /\$\$\$/;
                push( @episodeName, $` );
                print "episodeName[$videoIndex]= ($`)$&$'\n";

                $qdvdLine =~ /\$\$\$/;
                $temp = $';
                $temp =~ /%%%/;
                push( @episodeDesc, $` );
                print "episodeDesc[$videoIndex]= ($`)$&$'\n";

                # If the show title is in sage save file format then try and pull out the name
                if ( $showTitle[$videoIndex] =~ m#\w+-\w+-\d+-\d# )
                {
                    print "Show title in Sage show/episode save format.  Extracting info\n";
                    $workingLine = $&;
                    $workingLine =~ /\w+/;
                    $showTitle[$videoIndex] = $&;
                    $' =~ /\w+/;
                    $episodeName[$videoIndex] = $&;
                    $episodeDesc[$videoIndex] = "";
                    $showTitle[$videoIndex]   =~ s#([A-Z])# $1#g;
                    $showTitle[$videoIndex]   =~ s# ([A-Z])#$1#;
                    $episodeName[$videoIndex] =~ s#([A-Z])# $1#g;
                    $episodeName[$videoIndex] =~ s# ([A-Z])#$1#;
                    print "  Updated showTitle[$videoIndex] = $showTitle[$videoIndex]\n";
                    print "  Updated episodeName[$videoIndex] = $episodeName[$videoIndex]\n";
                }
                elsif ( $showTitle[$videoIndex] =~ m#\w+-\d+-\d# )
                {
                    print "Show title in Sage show only save format.  Extracting info\n";
                    $workingLine = $&;
                    $workingLine =~ /\w+/;
                    $showTitle[$videoIndex]   = $&;
                    $episodeName[$videoIndex] = "";
                    $episodeDesc[$videoIndex] = "";
                    $showTitle[$videoIndex] =~ s#([A-Z])# $1#g;
                    $showTitle[$videoIndex] =~ s# ([A-Z])#$1#;
                    print "  Updated showTitle[$videoIndex] = $showTitle[$videoIndex]\n";
                }
            }
            else
            {    # If it's an .avi
                push( @episodeDesc, " " );

                $qdvdLine =~ /!!!/;
                $temp = $';
                $temp =~ /@@@/;
                push( @archiveVideo, $` );
                print "archiveVideo[$videoIndex] = ($`)$&$'\n";

                push( @archiveVideo, "false" );

                if ( $file[$videoIndex] =~ /$aviInfoRegEx/ )
                {
                    print "Avi Info[$videoIndex]= ($`)$&($')\n";
                    push( @showTitle,   $` );
                    push( @episodeName, $' );
                }
                else
                {
                    push( @showTitle,   $fileName[$videoIndex] );
                    push( @episodeName, " " );
                }
            }

            if ( -e "$fullPath[$videoIndex].xml" )
            {
                if ( open( XMLFILE, "$fullPath[$videoIndex].xml" ) )
                {
                    print "Found xml file, attempting to get info:\n";
                    while (<XMLFILE>)
                    {
                        $xmlLine = $_;
                        chomp($xmlLine);
                        if ( $xmlLine =~ /<title>/ && $xmlLine =~ m#</title># )
                        {
                            $xmlLine =~ m#</title>#;
                            $`       =~ /<title>/;
                            $showTitle[$videoIndex] = $';
                            print "  Updated showTitle[$videoIndex] = $showTitle[$videoIndex]\n";
                        }

                        if ( $xmlLine =~ /<episode>/ && $xmlLine =~ m#</episode># )
                        {
                            $xmlLine =~ m#</episode>#;
                            $`       =~ /<episode>/;
                            $episodeName[$videoIndex] = $';
                            print "  Updated episodeName[$videoIndex] = $episodeName[$videoIndex]\n";
                        }

                        if ( $xmlLine =~ /<description>/ && $xmlLine =~ m#</description># )
                        {
                            $xmlLine =~ m#</description>#;
                            $`       =~ /description>/;
                            $episodeDesc[$videoIndex] = $';
                            print "  Updated episodeDesc[$videoIndex] = $episodeDesc[$videoIndex]\n";
                        }
                    }
                }
            }
            elsif ( -e "$fullFile[$videoIndex].my" )
            {    # Add support for .my files
                if ( open( MYFILE, "$fullFile[$videoIndex].my" ) )
                {
                    print "Found .my file, attempting to get info:\n";
                    while (<MYFILE>)
                    {
                        $xmlLine = $_;
                        chomp($xmlLine);
                        if ( $xmlLine =~ /title=/ )
                        {
                            $xmlLine =~ m#title=#;
                            $showTitle[$videoIndex] = $';
                            print "  Updated showTitle[$videoIndex] = $showTitle[$videoIndex]\n";
                        }

                        if ( $xmlLine =~ /TVEpisode=/ )
                        {
                            $xmlLine =~ m#TVEpisode=#;
                            $episodeName[$videoIndex] = $';
                            print "  Updated episodeName[$videoIndex] = $episodeName[$videoIndex]\n";
                        }

                        if ( $xmlLine =~ /TVOverview=/ )
                        {
                            $xmlLine =~ m#TVOverview=#;
                            $episodeDesc[$videoIndex] = $';
                            print "  Updated episodeDesc[$videoIndex] = $episodeDesc[$videoIndex]\n";
                        }
                    }
                }
            }

            if ($showTitle[$videoIndex] =~ /$aviInfoRegEx/)
            {   #If the show title matches the regEx then an xml or my file overwrote it with bad info
                $file[$videoIndex] =~ /$aviInfoRegEx/;
                $showTitle[$videoIndex] = $`;
                $episodeName[$videoIndex] =  $';
            }
        }

        # If an edl file exits and we're editing commercials, find the duration
        if ( -s "$fullFile[$videoIndex].edl"        &&
             ( ( $editCommercialsCompress == 1        &&
                 ( $targetFormat eq "xvid"              ||
                   $targetFormat eq "vidLib" ) )        ||
               ( $editCommercialsDVD == 1             &&
                 $targetFormat eq "dvd" ) ) )
        {
            # Calculate removed time and subtract from estimate
            open( EDL, "$fullFile[$videoIndex].edl" );
            $commDuration[$videoIndex] = 0;
            while (<EDL>)
            {
                if ( $_ =~ /\d*\.\d\d/ )
                {
                    $firstNumber = $&;
                    $theRest    = $';
                    $theRest =~ /\d*\.\d\d/;
                    $secondNumber = $&;
                    chomp($firstNumber);
                    chomp($secondNumber);
                    $commDuration[$videoIndex] += ( $secondNumber - $firstNumber );
                }
            }
            close(EDL);
            $commDuration[$videoIndex] = $commDuration[$videoIndex] / 60;    # seconds to minutes
            print "Video contains $commDuration[$videoIndex] minutes of commercials\n";
            $cuttingComm[$videoIndex] = 1;
        }
        else
        {
            $cuttingComm[$videoIndex] = 0;
        }

        # Get Video Info
        $ffmpegString = "\"$ffmpeg\" -i \"$fullPath[$videoIndex]\" -t 1 \"$scratchPath[$videoIndex]\\temp.mpg\" 2> \"$scratchPath[$videoIndex]\\$file[$videoIndex].vidInfo.txt\"";
        print "Getting Video Info: $ffmpegString\n";
        `$ffmpegString`;

        if ( !open( VIDEOINFO, "$scratchPath[$videoIndex]\\$file[$videoIndex].vidInfo.txt" ) )
        {
            updateStatusImage( "error", "Couldn't open $file[$videoIndex].vidInfo.txt", @statusImageArray );
        }

        while (<VIDEOINFO>)
        {
            if ( $_ =~ m#I/O error occured# )
            {
                updateStatusImage( "error", "Error in $file[$videoIndex].vidInfo.txt.  Original video probably doens't exist", @statusImageArray );
            }

            if ( $_ =~ /Video:/ )
            {
                print "Video Info Line[$videoIndex]: $_";
                $infoLine = $_;

                # Get Resolution
                $infoLine =~ /\d{3,4}x\d{3,4}/;
                $temp = $&;
                chomp($temp);
                print "Resolution[$videoIndex]  = $temp\n";
                push( @resolution, $temp );

                # Get aspect ratio
                $resolution[$videoIndex] =~ /x/;
                $width      = $`;
                $hight      = $';
                $fullOrWide = $width / $hight;
                if ( $fullOrWide < 1.55 )
                {
                    push( @aspectRatio, "4:3" );
                    push( @widescreen,  "noletterbox" );
                }
                else
                {
                    push( @aspectRatio, "16:9" );
                    push( @widescreen,  "nopanscan" );
                }
                print "aspectRatio[$videoIndex]  = $aspectRatio[$videoIndex]\n";

                if ($infoLine =~ /AR:.*,/)
                {
                    $& =~ /\d+:\d+/;
                    $ffmpegReportedAR[$videoIndex] = $&;
                    print "Old Meathod = $aspectRatio[$videoIndex], New Meathod = $ffmpegReportedAR[$videoIndex]\n";
                }

                if ($infoLine =~ /interlaced/)
                {
                    print "FFmpeg reports interlaced\n";
                    $interlaced[$videoIndex] = 1;
                }

                if ($infoLine =~ /progressive/)
                {
                    print "FFmpeg reports progressive scan\n";
                    $interlaced[$videoIndex] = 0;
                }

                # Get Bitrate
                $infoLine =~ /\d+ kb/;
                $&        =~ /\d+/;
                $temp = $&;
                chomp($temp);
                print "Bitrate[$videoIndex]     = $temp\n";
                push( @bitrates, $temp );

                # Get Framerate
                $infoLine =~ /fps/;
                $`        =~ /, /;
                $temp = $';
                chomp($temp);
                print "Frame Rate[$videoIndex]  = $temp\n";
                push( @frameRate, $temp );

                # Get video format
                $infoLine =~ /Video: /;
                $'        =~ /,/;
                $temp = $`;
                chomp($temp);
                print "Format[$videoIndex]      = $temp\n";
                push( @format, $temp );
                if ( $targetFormat =~ /dvd/ && $format[$videoIndex] eq "mpeg2video" )
                {
                    push( @transcodeOrder, $videoIndex );
                }
                else
                {    # non-mpeg2 video often transcode smaller so do them first
                    unshift( @transcodeOrder, $videoIndex );
                }

                # If  the file is eligible for muxing, do a quick test DVD to check for detectable errors
                $foundError = 0;
                if ( $targetFormat            =~ /dvd/              &&
                     $resolution[$videoIndex] =~ "$dvdResolution"   &&
                     $frameRate[$videoIndex]  =~ "$dvdFrameRate"    &&
                     $format[$videoIndex]     =~ "mpeg2video"       &&
                     $disableTestDVD          != 1)
                {
                    $ffmpegString = "\"$ffmpeg\" -i \"$fullPath[$videoIndex]\" -target $ffmpegTargetFormat -acodec copy -vcodec copy -t 10 \"$scratchPath[$videoIndex]\\$file[$videoIndex].test.mpg\"";
                    print "Generating mpeg for test DVD: $ffmpegString\n";
                    `$ffmpegString`;

                    # Create Video_TS folder with dvdauthor
                    if ( -e "$scratchPath[$videoIndex]\\testDVD" )
                    {
                        `rd /S /Q "$scratchPath[$videoIndex]\\testDVD\"`;
                    }
                    `mkdir "$scratchPath[$videoIndex]\\testDVD"`;
                    unless ( open( XMLCONFIG, ">$scratchPath[$videoIndex]\\$file[$videoIndex].config.xml" ) )
                    {
                        updateStatusImage( "error", "can't open config.xml", @statusImageArray );
                    }

                    print XMLCONFIG "<dvdauthor dest=\"$scratchPath[$videoIndex]\\testDVD\">\n";
                    print XMLCONFIG "<vmgm />\n";
                    print XMLCONFIG "<titleset>\n";
                    print XMLCONFIG "<titles>\n";
                    print XMLCONFIG "<pgc>\n";
                    print XMLCONFIG "<vob file=\"$scratchPath[$videoIndex]\\$file[$videoIndex].test.mpg\"/>\n";
                    print XMLCONFIG "</pgc>\n";
                    print XMLCONFIG "</titles>\n";
                    print XMLCONFIG "</titleset>\n";
                    print XMLCONFIG "</dvdauthor>\n";
                    close(XMLCONFIG);
                    $dvdAuthorString = "\"$dvdAuthor\" -x \"$scratchPath[$videoIndex]\\$file[$videoIndex].config.xml\" 2> \"$scratchPath[$videoIndex]\\$file[$videoIndex].dvdInfo.txt\"";
                    print "Creating DVD File Structure: $dvdAuthorString\n";
                    `$dvdAuthorString`;

                    # Checking for errors
                    unless ( open( DVDINFO, "$scratchPath[$videoIndex]\\$file[$videoIndex].dvdInfo.txt" ) )
                    {
                        updateStatusImage( "error", "Couldn't open $file[$videoIndex].dvdInfo.txt", @statusImageArray );
                    }

                    # Parse dvdauthor output file for errors
                    while (<DVDINFO>)
                    {
                        if ( $_ =~ /ERR:/ )
                        {
                            if ( $foundError == 0 )
                            {
                                print "Error found in test DVD, forcing transcode\n";
                            }
                            $foundError = 1;
                        }
                    }
                    close(DVDINFO);
                }
                push( @forceTranscode, $foundError );
                last;
            }
            elsif ( $_ =~ /Duration:/ )
            {
                print "Duration Line[$videoIndex]: $_";
                $infoLine = $_;
                $infoLine =~ /[0-9][0-9:\.]+/;
                $duration = $&;
                $duration =~ /:/;
                $hour = $`;
                $rest = $';
                $rest =~ /:/;
                $minute = $`;
                $second = $';
                print "hours[$videoIndex]    = $hour\n";
                print "minutes[$videoIndex]  = $minute\n";
                print "seconds[$videoIndex]  = $second\n";
                push( @durations, $hour * 60 + $minute + $second / 60 );
                print "totalMin[$videoIndex] = $durations[$videoIndex]\n";

                $infoLine =~ /bitrate: /;
                $'        =~ / kb/;
                push( @ffmpegCalcBitrate, $` );
            }
        }

        if ( $resolution[ $videoIndex ] =~ /\d+x(1080|720)$/ &&
             $extention[ $videoIndex ]  =~ /(mpg|mpeg|ts)/   )
        {   # HDTV!
            $hdtv[ $videoIndex ] = 1;
        }
        else
        {
            $hdtv[ $videoIndex ] = 0;
        }

        # If it's being compressed pull out the profile
        if ( $targetFormat eq "xvid" || $targetFormat eq "vidLib" )
        {

            if ($compressMode == 0)
            {
                $qdvdLine =~ /!!!/;
                $temp = $';
                $temp =~ /@@@/;
                push( @archiveVideo, $` );
                print "archiveVideo[$videoIndex] = ($`)$&$'\n";

                if ($archiveVideo[$videoIndex] eq "")
                {
                    # Check for custom profile vs res
                    print "No profile specified, looking for default\n";
                    $checkForProfile = "perl2DVD_default";
                    @customProfile   = ();
                    @customProfile   = split( /,/, $defaultTransProfile );
                    foreach $dfltProfile (@customProfile)
                    {
                        if ( $dfltProfile =~ /::/ )
                        {
                            $origRes  = $`;
                            $desiredProfile = $';
                            chomp($origRes);
                            chomp($desiredProfile);
                            $regExExp = $origRes . "x";
                            if ( $resolution[ $videoIndex ] =~ /$regExExp/ )
                            {
                                print "Default Profile found, $origRes = $resolution[ $videoIndex ], using $desiredProfile\n";
                                $checkForProfile = $desiredProfile;
                            }
                        }
                    }
                }
                else
                {
                    $checkForProfile = $archiveVideo[$videoIndex];
                }
            }
            else
            {
                $checkForProfile = $ARGV[1];
            }
            print "Looking for profile: $checkForProfile\n";

            $profileFound = 0;
            while ($profileFound != 1)
            {
                for $profile (@mencoderProfiles)
                {   # perl2DVD_default should always be last
                    if ( @$profile[0] eq $checkForProfile || @$profile[0] eq "perl2DVD_default" )
                    {
                        $transProfile[$videoIndex]   = @$profile[0];
                        $encDefault[$videoIndex]     = @$profile[1];
                        $encOptsPassOne[$videoIndex] = @$profile[2];
                        $encOptsPassTwo[$videoIndex] = @$profile[3];
                        $container[$videoIndex]      = @$profile[4];
                        $mbPer30Min[$videoIndex]     = @$profile[5];
                        $customRes[$videoIndex]      = @$profile[6];
                        $audioOptions[$videoIndex]   = @$profile[7];
                        $copyAC3[$videoIndex]        = @$profile[8];
                        $estAudioSize[$videoIndex]   = @$profile[9];
                        $videoFilters[$videoIndex]   = @$profile[10];
                        $profileFound = 1;
                        last;
                    }
                }

                # Check for resolution profile override
                if ( $mbPer30Min[$videoIndex] =~ />>/)
                {
                    @customMbPer30Min   = ();
                    @customMbPer30Min   = split( /,/, $mbPer30Min[ $videoIndex ] );
                    foreach $mbPer30 (@customMbPer30Min)
                    {
                        if ( $mbPer30 =~ />>/ )
                        {
                            $origRes  = $`;
                            $overrideProfile = $';
                            chomp($origRes);
                            chomp($overrideProfile);
                            $regExExp = $origRes . "x";
                            if ( $resolution[ $videoIndex ] =~ /$regExExp/ )
                            {
                                print "Override Profile Found, $origRes = $resolution[ $videoIndex ], seaching for $overrideProfile\n";
                                $checkForProfile = $overrideProfile;
                                $mbPerMin = $desiredMbPer30Min/30;
                                $profileFound = 0;
                            }
                        }
                    }
                }
            }

            print "Using Profile \"$transProfile[$videoIndex]\":\n";
            print "\tdefault       : $encDefault[$videoIndex]\n";
            print "\tpass #1       : $encOptsPassOne[$videoIndex]\n";
            print "\tpass #2       : $encOptsPassTwo[$videoIndex]\n";
            print "\tcontainer     : $container[$videoIndex]\n";
            print "\tmb/30 min     : $mbPer30Min[$videoIndex]\n";
            print "\tCustom Res    : $customRes[$videoIndex]\n";
            print "\tAudio Opts    : $audioOptions[$videoIndex]\n";
            print "\tCopy AC3      : $copyAC3[$videoIndex]\n";
            print "\tEst. Aud Size : $estAudioSize[$videoIndex]\n";
            print "\tVideo Filters : $videoFilters[$videoIndex]\n";

            # PreGenerate filename for video import directory
            if ( $fullPath[$videoIndex] =~ m#\.(mpeg|mpg|ts)$# )
            {    # Its an mpeg from sage, use the video info for the video import name
                if ( $episodeName[$videoIndex] eq "" )
                {
                    push( @videoImportName, "$showTitle[$videoIndex] - $startTime $startDate.$container[$videoIndex]" );
                }
                else
                {
                    push( @videoImportName, "$showTitle[$videoIndex] - $episodeName[$videoIndex].$container[$videoIndex]" );
                }
            }
            else
            {    # Not an mpeg so keep the original name
                push( @videoImportName, "$fileName[$videoIndex]" );
            }

            # Strip out illiegal Chars
            $videoImportName[$videoIndex] =~ s#($illCharFileRegEx)##g;
            $videoImportName[$videoIndex] =~ /\.$container[$videoIndex]/;
            push( @videoImportFile, $` );

            print "Filename for video import directory[$videoIndex] = $videoImportName[$videoIndex]\n";
        }

        # PreGenerate Transcoded file name
        if ( $targetFormat =~ /dvd/ )
        {
            push( @transFile,     "$file[$videoIndex].2dvd" );
            push( @transPath,     "$scratchPath[$videoIndex]\\$file[$videoIndex].2dvd" );
            push( @transFullFile, "$file[$videoIndex].2dvd.mpg" );
            push( @transFullPath, "$scratchPath[$videoIndex]\\$file[$videoIndex].2dvd.mpg" );
        }
        elsif ( $targetFormat =~ /xvid/ || $targetFormat =~ /vidLib/ )
        {
            # Get rid of any spaces in the profile
            $transProfile[$videoIndex] =~ s# #_#g;
            push( @transFile,     "$file[$videoIndex].2$transProfile[$videoIndex]" );
            push( @transPath,     "$scratchPath[$videoIndex]\\$file[$videoIndex].2_$transProfile[$videoIndex]" );
            push( @transFullFile, "$file[$videoIndex].2$transProfile[$videoIndex].$container[$videoIndex]" );
            push( @transFullPath, "$scratchPath[$videoIndex]\\$file[$videoIndex].2_$transProfile[$videoIndex].$container[$videoIndex]" );
        }
        print "Transcoded filename[$videoIndex] = $transFullPath[$videoIndex]\n";

        # If we're editing commercials, subtract the duration here
        if (  $cuttingComm[$videoIndex] == 1 )
        {
            $durations[$videoIndex] -= $commDuration[$videoIndex];
            print "Attempting to edit commercials, new duration = $durations[$videoIndex] minutes\n";
        }

        close(VIDEOINFO);
    }
}

if ($numberOfVideos == 0)
{
    print "Didn't find any videos... invalid qdvd file?\n";
    die;
    updateStatusImage( "error", "Didn't find any valid lines in qdvd file", @statusImageArray );
}

# delete test DVD folder if it exists
if ( -e "$scratchPath[$videoIndex]\\testDVD" )
{
    `rd /S /Q "$scratchPath[$videoIndex]\\testDVD\"`;
}

#Calculate bitrates
if ( $targetFormat =~ /dvd/ )
{
    print "\n------------ Calculating Bitrates ----------------\n";
    $sumOfDurations = 0;
    for ( $i = 0 ; $i < @durations ; $i++ )
    {
        $sumOfDurations += $durations[$i];
    }
    $totalKiloBits = ( ( $targetSize * 1000000000 ) * 8 ) / 1024;
    $bitrate = ( ($totalKiloBits) / ( 60 * $sumOfDurations ) );
    $bitrate = sprintf( "%d", $bitrate );    #round to int

    $mpegAdjust = nOrderEQ( $bitrate, @hdtvAdjustmentCoefs );
    $aviAdjust  = nOrderEQ( $bitrate, @aviAdjustmentCoefs );
    $mpegBitrate = $bitrate - $mpegAdjust;
    $aviBitrate  = $bitrate - $aviAdjust;

    print "Total DVD time = " . ($sumOfDurations) . " minutes\n";
    print "# of Videos    = $numberOfVideos\n";
    print "Avg Bitrate    =  $bitrate\n";
    if ( $bitrate > $maxBitrate )
    {
        print "Bitrate too high for DVD standard, reducing -> $maxBitrate\n";
        $bitrate     = $maxBitrate;
        $mpegBitrate = $bitrate - nOrderEQ( $bitrate, @hdtvAdjustmentCoefs );
        $aviBitrate  = $bitrate - nOrderEQ( $bitrate, @aviAdjustmentCoefs );
    }
}
elsif ( $targetFormat =~ /xvid/ || $targetFormat =~ /vidLib/ )
{
    print "\n# of Videos    = $numberOfVideos\n";
}

#-------------- ffmpeg Loop ----------------
print "\n------------ Starting Transcoding ----------------\n";
if ( $targetFormat =~ /dvd/ )
{
    $leftOvers = 0;
    $mux       = 0;

    for ( $videoIndex = 0 ; $videoIndex < $numberOfVideos ; $videoIndex++ )
    {
        print "------------ ffmpeg Loop #$videoIndex ----------------\n";
        # Get Start Time
        ( $startSecond, $startMinute, $startHour, $dayOfMonth, $month, $yearOffset, $dayOfWeek, $dayOfYear, $daylightSavings ) = localtime();

        $extentions[$transcodeOrder[$videoIndex]] =~ /\./;
        $origExt = $';
        if ( !($hdtv[$transcodeOrder[$videoIndex]] == 1) )
        {    #Not HDTV Mpeg
            if ( $cuttingComm[$transcodeOrder[$videoIndex]] == 1 )
            {
                print "Editing out $commDuration[$transcodeOrder[$videoIndex]] minutes of commercials\n";
                $edlString = "-edl \"$fullFile[$transcodeOrder[$videoIndex]].edl\"";
            }
            else
            {
                $edlString = "";
            }

            $cutMpeg   = "$transPath[$transcodeOrder[$videoIndex]].2cut.$origExt";

            # Set input to cutMpeg
            $inputFile = $cutMpeg;

            if ($origExt =~ /(mpg|mpeg|ts)/)
            {   # If it's an mpeg
                # To cut with the edl first we need to wash the mpeg with ffmpeg
                print "Cleaning up the mpg a little big...\n";
                $cleanMpeg = "$transPath[$transcodeOrder[$videoIndex]].2clean.$origExt";
                $ffmpegBatch   = "$ffmpegEXE -i \"$fullPath[$transcodeOrder[$videoIndex]]\" -acodec copy -vcodec copy \"$cleanMpeg\"";
                print "Washing: $ffmpegBatch\n";
                # Set -of to mpeg for mencoder
                $outFormat = "-of mpeg";
                $cleanNCutBatchFile = "$transPath[$transcodeOrder[$videoIndex]].2cleanNcut.bat";

            }
            else
            {   # If it's not an mpeg
                $outFormat = "";
                $cleanMpeg = $fullPath[$transcodeOrder[$videoIndex]];
                $cleanNCutBatchFile = "$transPath[$transcodeOrder[$videoIndex]].2cut.bat";
            }

            $mencoderBatch = "$mencoderEXE \"$cleanMpeg\" $edlString -ovc copy -oac copy $outFormat -o \"$cutMpeg\"";
            print "Rinsing: $mencoderBatch\n";

            # Create transcoding batchfile
            print "*************  Creating ffmpeg cleaning and commercial cutting batch file\n ";
            unless ( open( BATFILE, ">$cleanNCutBatchFile" ) )
            {
                updateStatusImage( "error", "can't create audio transcode batch file $videoIndex", @statusImageArray );
            }
            print BATFILE       "$sageDrive\n";
            print BATFILE       "cd \"$sageDir\\perl2dvd\"\n";
            if ($origExt =~ /(mpg|mpeg|ts)/)
            {   # If its not an mpeg, we don't need to do this
                print BATFILE   "start /B /$transcodePriority /WAIT $ffmpegBatch\n";
            }
            print BATFILE       "start /B /$transcodePriority /WAIT $mencoderBatch\n";

            # Delete the clean mpeg to save space
            if ($origExt =~ /(mpg|mpeg|ts)/ && $debugDelete == 0)
            {   # If its not an mpeg, we don't need to do this
                print BATFILE   "del \"$cleanMpeg\"\n";
            }
            close(BATFILE);
            print "<** Done\n";

            if ( !( -e "$cutMpeg" ) )
            {   # Only run batch file if .2cut file doesn't exist
                print "Running cleaning and cutting batch file with priority $transcodePriority: \"$cleanNCutBatchFile\"\n";
                `"$cleanNCutBatchFile" > "$cleanNCutBatchFile.log"`;
            }
            else
            {
                print "Cut Mpeg already exsists\n"
            }
        }
        else
        {   # If it's HDTV, we'll use the old way because we know it works
            $inputFile = $fullPath[$transcodeOrder[$videoIndex]];
        }

        # Default output file
        $outputFile = "$transFullPath[$transcodeOrder[$videoIndex]]";
        if ( $hdtv[$transcodeOrder[$videoIndex]] == 1 )
        {    #HDTV mpeg
            print "HDTV mpeg path\n";
            $usedBitrate  = $mpegBitrate;
            if ( $cuttingComm[$transcodeOrder[$videoIndex]] == 1)
            {
                $outputFile =  "$transPath[$transcodeOrder[$videoIndex]].2ffmpegDVD.mpg";
                $ffmpegDVD = $outputFile;
            }
            $ffmpegBatch  = "$ffmpegEXE -i \"$inputFile\" -target $ffmpegTargetFormat -s $dvdResolution $ffmpegSwitchesHDTV -b $usedBitrate \"$outputFile\"";
        }
        elsif ( $extention[ $transcodeOrder[$videoIndex] ] =~ /(mpg|mpeg|ts)/ )
        {    #non-HDTV mpeg
            print "Non-HDTV mpeg path\n";
            # Check if mpeg is already in DVD format
            if ( $resolution[ $transcodeOrder[$videoIndex] ] =~ "$dvdResolution" &&
                 $frameRate[ $transcodeOrder[$videoIndex] ]  =~ "$dvdFrameRate"  &&
                 $format[ $transcodeOrder[$videoIndex] ]     =~ "mpeg2video" )
            {
                $originalFileSize = -s "$inputFile";             # File size in bytes
                $originalFileSize = $originalFileSize / 1024;    # File Size in kilobytes
                $originalFileSize *= 8;                          # File size in kilobits
                $originalFileSize -= ( $demuxCorrection * $durations[ $transcodeOrder[$videoIndex] ] ) * 1024 * 8;

                # Equasion to deterimine if SDTV shows get recompressed
                print "$originalFileSize < $totalKiloBits * ($durations[$transcodeOrder[$videoIndex]]/$sumOfDurations)\n";
            }

            # Setup ffmpeg equasions
            $usedBitrate = $mpegBitrate;
            if ( ( $resolution[ $transcodeOrder[$videoIndex] ]      =~ "$dvdResolution"     &&
                   $frameRate[ $transcodeOrder[$videoIndex] ]       =~ "$dvdFrameRate"      &&
                   $format[ $transcodeOrder[$videoIndex] ]          =~ "mpeg2video"         &&
                   $forceTranscode[ $transcodeOrder[$videoIndex] ]  != 1 )                  &&
                 $originalFileSize < ( $totalKiloBits * ( $durations[ $transcodeOrder[$videoIndex] ] / $sumOfDurations ) ) )
            {    # Already in DVD format
                print "No Transcoding nessisary.  Adding Nav Packets\n";
                $mux          = 1;
                $ffmpegBatch  = "$ffmpegEXE -i \"$inputFile\" -target $ffmpegTargetFormat -acodec copy -vcodec copy \"$outputFile\"";
            }
            else
            {    # Needs to be transcoded to DVD format
                $ffmpegBatch  = "$ffmpegEXE -i \"$inputFile\" -target $ffmpegTargetFormat  -s $dvdResolution $ffmpegSwitches -b $usedBitrate \"$outputFile\"";
            }
        }
        elsif ( $extention[ $transcodeOrder[$videoIndex] ] =~ /avi/ )
        {    # Avi's
            print "Avi path\n";
            $usedBitrate  = $aviBitrate;
            $ffmpegBatch  = "$ffmpegEXE -i \"$inputFile\" -target $ffmpegTargetFormat -s $dvdResolution $ffmpegSwitches -b $usedBitrate \"$outputFile\" ";
        }
        print "Transcoding Video: $ffmpegBatch\n";

        # Create transcoding batchfile
        print "*************  Creating transcoding batch file\n";
        unless ( open( BATFILE, ">$transPath[$transcodeOrder[$videoIndex]].bat" ) )
        {
            updateStatusImage( "error", "can't create transcode batch file $videoIndex", @statusImageArray );
        }
        print BATFILE "$sageDrive\n";
        print BATFILE "cd \"$sageDir\\perl2dvd\"\n";
        print BATFILE "start /B /$transcodePriority /WAIT $ffmpegBatch\n";
        close(BATFILE);
        print "<** Done\n";
        if ( !( -e "$outputFile" ) )
        {
            print "Running batch file with priority $transcodePriority: \"$transPath[$transcodeOrder[$videoIndex]].bat\"\n";
            `"$transPath[$transcodeOrder[$videoIndex]].bat" 2> "$transPath[$transcodeOrder[$videoIndex]].trans.log"`;
        }
        else
        {
            print "DVD mpeg already exists\n";
        }

        if ( $hdtv[$transcodeOrder[$videoIndex]] == 1 &&
             $cuttingComm[$transcodeOrder[$videoIndex]] == 1)
        {   # if HDTV, cut commercials after compress
            print "Editing out $commDuration[$transcodeOrder[$videoIndex]] minutes of commercials\n";
            $edlString = "-edl \"$fullFile[$transcodeOrder[$videoIndex]].edl\"";
            $cdDir     = "$sageDir\\perl2dvd";
            $cutMpeg   = "$transPath[$transcodeOrder[$videoIndex]].2cut.mpg";
            $cutBatchFile = "$transPath[$transcodeOrder[$videoIndex]].2cutNClean.bat";
            # Cut
            $mencoderBatch = "$mencoderEXE \"$ffmpegDVD\" $edlString -ovc copy -oac copy -of mpeg -o \"$cutMpeg\"";
            print "Cutting: $mencoderBatch\n";
            # Add Nav Packets again
            $ffmpegBatch   = "$ffmpegEXE -i \"$cutMpeg\" -target $ffmpegTargetFormat -acodec copy -vcodec copy \"$transFullPath[$transcodeOrder[$videoIndex]]\"";
            print "Rinsing: $ffmpegBatch\n";

            # Create transcoding batchfile
            print "*************  Creating commercial cutting batch file\n ";
            unless ( open( BATFILE, ">$cutBatchFile " ) )
            {
                updateStatusImage( "error", "can't create commercial cutting batch file $videoIndex", @statusImageArray );
            }
            print BATFILE       "$sageDrive\n";
            print BATFILE       "cd \"$sageDir\\perl2dvd\"\n";
            print BATFILE       "start /B /$transcodePriority /WAIT $mencoderBatch\n";
            print BATFILE       "start /B /$transcodePriority /WAIT $ffmpegBatch\n";

            # Delete the uncut mpeg to save space
            if ($debugDelete == 0)
            {
                print BATFILE   "del \"$ffmpegDVD\"\n";
                print BATFILE   "del \"$cutMpeg\"\n";
            }
            close(BATFILE);
            print "<** Done\n";

            if ( !( -e "$transFullPath[$transcodeOrder[$videoIndex]]" ) )
            {   # Only run batch file if .2cut file doesn't exist
                print "Running cutting batch file with priority $transcodePriority: \"$cutBatchFile\"\n";
                `"$cutBatchFile" > "$cutBatchFile.log"`;
            }
            else
            {
                print "Cut Mpeg already exsists\n"
            }
            # Adjust Duration
        }

        # Get Finish Time
        ( $finishSecond, $finishMinute, $finishHour, $dayOfMonth, $month, $yearOffset, $dayOfWeek, $dayOfYear, $daylightSavings ) = localtime();

        # Print transcode stats
        if ( $extention[ $transcodeOrder[$videoIndex] ] =~ /(mpg|mpeg|ts)/ )
        {    # add the adjustment back in if nessisary
            $usedBitrate += $hdtvBitrateAdjustment;
        }

        if ( !( -e "$transFullPath[$transcodeOrder[$videoIndex]]" ) )
        {
            updateStatusImage( "error", "Could not find $transFullPath[$transcodeOrder[$videoIndex]]", @statusImageArray );
        }

        $actualFileSize = -s "$transFullPath[$transcodeOrder[$videoIndex]]";
        $actualFileSize = $actualFileSize / 1024;
        # plus .1 prevents divide by zero
        $targetFileSize = ( $totalKiloBits * ( $durations[ $transcodeOrder[$videoIndex] ] / $sumOfDurations ) ) / 8 + .1;
        $percentError   = ( $actualFileSize / $targetFileSize ) * 100;

        # handle negative times
        if ( $finishSecond < $startSecond )
        {
            $finishSecond += 60;
            $finishMinute--;
        }
        if ( $finishMinute < $startMinute )
        {
            $finishMinute += 60;
            $finishHour--;
        }
        if ( $finishHour < $startHour )
        {
            $finishHour += 24;
        }

        $actBitrate = ( 8 * $actualFileSize ) / ( 60 * $durations[ $transcodeOrder[$videoIndex] ] );
        $durHour = sprintf( "%02d", ( $finishHour - $startHour ) );
        $durMin  = sprintf( "%02d", ( $finishMinute - $startMinute ) );
        $durSec  = sprintf( "%02d", ( $finishSecond - $startSecond ) );
        $transcodeTime = $durHour . ":" . $durMin . ":" . $durSec;

        print "\nFFMPEG Transcode Stats:\n";
        print "Video Duration[$transcodeOrder[$videoIndex]]   = $durations[$transcodeOrder[$videoIndex]]\n";
        print "Actual Bitrate[$transcodeOrder[$videoIndex]]   = $actBitrate\n";
        print "Target Bitrate[$transcodeOrder[$videoIndex]]   = $bitrate\n";
        print "Actual File Size[$transcodeOrder[$videoIndex]] = $actualFileSize\n";
        print "Target File Size[$transcodeOrder[$videoIndex]] = $targetFileSize\n";
        print "Percent [$transcodeOrder[$videoIndex]]         = $percentError\n";
        print "Total Trans Time[$transcodeOrder[$videoIndex]] = $transcodeTime\n\n";

        # Maintain a stat file to gather data for better equasions
        if ( $mux != 1 )
        {
            open( STATFILE, ">>$scratchPathIMG\\bitrates.stats" );
            print STATFILE "$format[$transcodeOrder[$videoIndex]]###";
            print STATFILE "$durations[$transcodeOrder[$videoIndex]]###";
            print STATFILE "$bitrate###$targetFileSize###$actBitrate###";
            print STATFILE "$actualFileSize###";
            print STATFILE "$percentError\n";
            close(STATFILE);
            $mux = 0;
        }

        # Recalculate bitrates
        if ( ( $videoIndex + 1 ) != $numberOfVideos )
        {
            $totalKiloBits  -= $actualFileSize * 8;
            $sumOfDurations -= $durations[ $transcodeOrder[$videoIndex] ];
            $bitrate = ( ($totalKiloBits) / ( 60 * $sumOfDurations ) );
            $bitrate = sprintf( "%d", $bitrate );    #round to int
            if ( $percentError > 100 )
            {
                $bitrate -= 100;
            }
            $mpegBitrate = $bitrate - $mpegAdjust;
            $aviBitrate  = $bitrate - $aviAdjust;

            print "Remaining DVD time = " . ($sumOfDurations) . " minutes\n";
            print "# of Videos Remaining   = " . ( $numberOfVideos - ( $videoIndex + 1 ) ) . "\n";
            print "Updated Avg Bitrate    =  $bitrate\n";
            if ( $bitrate > $maxBitrate )
            {
                print "Bitrate too high for DVD standard, reducing -> $maxBitrate\n";
                $bitrate     = $maxBitrate;
                $mpegBitrate = $bitrate - nOrderEQ( $bitrate, @hdtvAdjustmentCoefs );
                $aviBitrate  = $bitrate - nOrderEQ( $bitrate, @aviAdjustmentCoefs );
            }
            print "\n";
        }

        # Grap the commercials from the comskip file if it exists
        $chapters[ $transcodeOrder[$videoIndex] ] = "0";

        if ( ( -s "$fullFile[$transcodeOrder[$videoIndex]].txt"     ||
               -s "$fullFile[$transcodeOrder[$videoIndex]].edl"     ||
               -s "$fullFile[$transcodeOrder[$videoIndex]].txtcut"  ||
               -s "$fullFile[$transcodeOrder[$videoIndex]].edlcut" ) )
        {
            $useCUT = 0;
            if ( -s "$fullFile[$transcodeOrder[$videoIndex]].edl" || -s "$fullFile[$transcodeOrder[$videoIndex]].edlcut" )
            {    # EDL format
                $useTXT = 0;
                open( COMSKIP, "$fullFile[$transcodeOrder[$videoIndex]].edl" );
                if ( -s "$fullFile[$transcodeOrder[$videoIndex]].edl" )
                {
                    open( COMSKIP, "$fullFile[$transcodeOrder[$videoIndex]].edl" );
                }
                elsif ("$fullFile[$transcodeOrder[$videoIndex]].edlcut")
                {
                    open( COMSKIP, "$fullFile[$transcodeOrder[$videoIndex]].edlcut" );
                    $useCUT = 1;
                }
            }
            elsif ( -s "$fullFile[$transcodeOrder[$videoIndex]].txt" || -s "$fullFile[$transcodeOrder[$videoIndex]].txtcut" )
            {    # TXT format
                $useTXT = 1;
                if ( -s "$fullFile[$transcodeOrder[$videoIndex]].txt" )
                {
                    open( COMSKIP, "$fullFile[$transcodeOrder[$videoIndex]].txt" );
                }
                elsif ("$fullFile[$transcodeOrder[$videoIndex]].txtcut")
                {
                    open( COMSKIP, "$fullFile[$transcodeOrder[$videoIndex]].txtcut" );
                    $useCUT = 1;
                }
            }

            if ( $hdtv[$transcodeOrder[$videoIndex]] == 1)
            {    # Is HDTV
                $comskipOffset = $HDTVcomskipOffset;
            }
            else
            {    # Is SDTV
                $comskipOffset = $SDTVcomskipOffset;
            }

            # Throw away first two lines
            if ( $useTXT == 1 )
            {
                <COMSKIP>;
                <COMSKIP>;
            }

            # If we're currently cutting commercials, we need to enable useCut also
            if ( $cuttingComm[ $transcodeOrder[$videoIndex] ] == 1 )
            {
                $useCUT = 1;
            }

            if ( $useCUT == 1 )
            {
                print "This video should be cut.  Adjusting Chapters\n";
            }

            print "Commercials List from Comskip:\n";
            $comDrift     = 0;
            $firstChapter = 1;
            while (<COMSKIP>)
            {
                print $_;
                if ( $useTXT == 1 )
                {
                    $_ =~ /\d*./;
                    $firstNum  = $&;
                    $secondNum = $';
                    chomp($secondNum);
                    if ( $useCUT == 0 )
                    {
                        $startSecond = ( ( $secondNum / $frameRate[ $transcodeOrder[$videoIndex] ] ) );
                        $seconds = ( $startSecond % 60 );
                    }
                    else
                    {
                        $startSecond = ( ( $firstNum / $frameRate[ $transcodeOrder[$videoIndex] ] ) - $comDrift );
                        $seconds = ( $startSecond % 60 );
                        $comDrift += ( ( ( ( $secondNum - $firstNum ) / $frameRate[ $transcodeOrder[$videoIndex] ] ) ) % 60 );
                    }
                }
                else
                {    # EDL format
                    $_ =~ /\d*\.\d\d/;
                    $firstNum = $&;
                    $theRest  = $';
                    $theRest =~ /\d*\.\d\d/;
                    $secondNum = $&;
                    if ( $useCUT == 0 )
                    {
                        $startSecond = $secondNum;
                        $seconds     = ( $startSecond % 60 );
                    }
                    else
                    {
                        $startSecond = $firstNum - $comDrift;
                        $seconds     = ( $startSecond % 60 );
                        $comDrift += $secondNum - $firstNum;
                    }
                    chomp($seconds);
                }

                $seconds = $seconds - $comskipOffset;
                if ( $seconds < 0 && $minutes != 0 )
                {
                    $seconds = 60 - $seconds;
                    $minutes = $minutes - 1;
                }
                elsif ( $seconds < 0 && $minutes == 0 )
                {
                    $seconds = 0;
                }
                $minutes = $startSecond / 60;
                $time = sprintf( "%d:%02d", $minutes, $seconds );
                if ( $startFrame != -5 && !( $startSecond < $firstChapterMinTime && $useCUT == 1 ) )
                {
                    push( @times, "$time" );
                }
                $firstChapter = 0;
            }
            close COMSKIP;

            foreach $i (@times)
            {
                $chapters[ $transcodeOrder[$videoIndex] ] = $chapters[ $transcodeOrder[$videoIndex] ] . ",$i";
            }
            @times = ();
        }
        else
        {
            for ( $i = $defaultChap ; $i < ( $durations[ $transcodeOrder[$videoIndex] ] ) ; $i += $defaultChap )
            {
                $chapters[ $transcodeOrder[$videoIndex] ] = $chapters[ $transcodeOrder[$videoIndex] ] . ",$i:00";
            }
        }
        print "Duration = $durations[$transcodeOrder[$videoIndex]]\n";
        print "Video Chapters = $chapters[$transcodeOrder[$videoIndex]]\n";

        if ($debugDelete == 0 && -s "$cutMpeg")
        {
            $deleteString = "del $cutMpeg";
            print "Deleting: $deleteString\n";
            `$deleteSting`;
        }
    }
}
elsif ( $targetFormat =~ /xvid/ || $targetFormat =~ /vidLib/ )
{
    for ( $videoIndex = 0 ; $videoIndex < $numberOfVideos ; $videoIndex++ )
    {
        print "------------ mencoder Loop #$videoIndex ----------------\n";
        if ( !( $extention[ $transcodeOrder[$videoIndex] ] =~ /(mpg|mpeg|ts)/ ) )
        {
            if (-e "$fullFile[$transcodeOrder[$videoIndex]].edl" &&
                $cuttingComm[$transcodeOrder[$videoIndex]] == 1)
            {   # Not an mpeg, but it's got an edl file, so lets try and cut the commecrials
                print "\n*************  Cutting commercials\n";

                $extentions[$transcodeOrder[$videoIndex]] =~ /\./;
                $origExt = $';

                $cdDir = "$sageDir\\perl2dvd";
                $mencoderBatch = "$mencoderEXE  \"$fullPath[$transcodeOrder[$videoIndex]]\" -edl \"$fullFile[$transcodeOrder[$videoIndex]].edl\" -oac copy -ovc copy -o \"$transFullPath[$transcodeOrder[$videoIndex]]\"";
                $comCutBatch = "$transPath[$transcodeOrder[$videoIndex]].2cut.bat";

                print "Cleaning mpg: $mencoderBatch\n";
                # Create transcoding batchfile
                unless ( open( BATFILE, ">$comCutBatch" ) )
                {
                    updateStatusImage( "error", "can't create mencdoer comCutting batch file $videoIndex", @statusImageArray );
                }
                print BATFILE "$sageDrive\n";
                print BATFILE "cd \"$sageDir\\perl2dvd\"\n";
                print BATFILE "start /B /$transcodePriority /WAIT $mencoderBatch\n";
                close(BATFILE);
                if ( !( -e "$transFullPath[$transcodeOrder[$videoIndex]]" ) )
                {
                    print "Running mencoder cutting batch file with priority $transcodePriority: \"$comCutBatch\"\n";
                    `"$comCutBatch" > "$comCutBatch.log"`;
                }
                else
                {
                    print "Cut Video already exists\n";
                }

            }
            else
            {
                print "Video is not an mpg so i'm assuming its already compressed\n";
                $copystring = "copy \"$fullPath[$transcodeOrder[$videoIndex]]\" \"$transFullPath[$transcodeOrder[$videoIndex]]\"";
                print "Copying directly to work folder: $copystring\n";
                `$copystring`;
                $cuttingComm[$transcodeOrder[$videoIndex]] = 0;
            }
        }
        else    # It needs to be compressed
        {
            if ( !($hdtv[$transcodeOrder[$videoIndex]] == 1) )
            {   #Not HDTV Mpeg
                #always clean the mpeg
                print "\n*************  Creating ffmpeg cleaning batch file\n";
                $cleanMpeg   = "$transPath[$transcodeOrder[$videoIndex]].2clean.mpg";

                $cdDir = "$sageDir";
                $ffmpegBatch = "$ffmpegEXE -i \"$fullPath[$transcodeOrder[$videoIndex]]\" -acodec copy -vcodec copy \"$cleanMpeg\"";
                $cleanBatchFile = "$transPath[$transcodeOrder[$videoIndex]].2clean.bat";
                # Set the input file as the clean mpg
                $inputFile   = $cleanMpeg;

                print "Cleaning mpg: $ffmpegBatch\n";
                # Create transcoding batchfile
                unless ( open( BATFILE, ">$cleanBatchFile" ) )
                {
                    updateStatusImage( "error", "can't create ffmpeg cleaning batch file $videoIndex", @statusImageArray );
                }
                print BATFILE "$sageDrive\n";
                print BATFILE "cd \"$sageDir\\perl2dvd\"\n";
                print BATFILE "start /B /$transcodePriority /WAIT $ffmpegBatch\n";
                close(BATFILE);
                if ( !( -e "$cleanMpeg" ) )
                {
                    print "Running ffmpeg cleaning batch file with priority $transcodePriority: \"$cleanBatchFile\"\n";
                    `"$cleanBatchFile" > "$cleanBatchFile.log"`;
                }
                else
                {
                    print "Clean Mpeg already exists\n";
                }
                print "<** Done\n\n";
            }
            else
            {   # HDTV mpeg
                $inputFile = $fullPath[$transcodeOrder[$videoIndex]];
            }

            #Default output file
            $outputFile = "$transFullPath[$transcodeOrder[$videoIndex]]";
            if ( $cuttingComm[$transcodeOrder[$videoIndex]] == 1 &&
                 !($hdtv[$transcodeOrder[$videoIndex]] == 1))
            {   # If we're cutting commercials, set the edl string
                $edlString   = "-edl \"$fullFile[$transcodeOrder[$videoIndex]].edl\"";
                print "Editing out $commDuration[$transcodeOrder[$videoIndex]] minutes of commercials\n";
            }
            else
            {    # No edl file, use defaults
                $edlString = "";
            }

            $harddup = "";
            if ( $hdtv[$transcodeOrder[$videoIndex]]        == 1 &&
                 $copyAC3[ $transcodeOrder[$videoIndex] ]   == 8675309 )
            {    # If the audio is already in AC3 allow the option to just copy it
                print "Copying AC3 audio\n";
                $audioOptions[ $transcodeOrder[$videoIndex] ] = "copy";
                $harddup = ",harddup"
            }

            if ( $hdtv[$transcodeOrder[$videoIndex]]        == 1 &&
                 $cuttingComm[$transcodeOrder[$videoIndex]] == 1)
            {   # If its HDTV, cut the commercials aster we compress
                $outputFile = "$transPath[$transcodeOrder[$videoIndex]].2uncut.mpg";
                $uncutFile  = $outputFile;
            }

            # Estimate Audio
            if ( $estAudioSize[ $transcodeOrder[$videoIndex] ] == 0 )
            {    # This command will encode just the audio and we will use the resulting file size to better estimate the video size
                $audioFile = "$transPath[$transcodeOrder[$videoIndex]].audONly.avi";
                $mencoderBatch_Audio = "\"$inputFile\" $edlString $audioOptions[$transcodeOrder[$videoIndex]] -ovc frameno -o \"$audioFile\"";
                $audioBatchFile = "$transPath[$transcodeOrder[$videoIndex]].2Audio.bat";

                # Create transcoding batchfile
                print "*************  Creating audio transcoding batch file\n";
                print "Estimating Audio: $mencoderBatch_Audio\n";
                unless ( open( BATFILE, ">$audioBatchFile" ) )
                {
                    updateStatusImage( "error", "can't create audio transcode batch file $videoIndex", @statusImageArray );
                }
                print BATFILE "$sageDrive\n";
                print BATFILE "cd \"$sageDir\\perl2dvd\"\n";
                print BATFILE "start /B /$transcodePriority /WAIT $mencoderEXE $mencoderBatch_Audio\n";
                close(BATFILE);
                if ( !( -e "$audioFile" ) )
                {
                    print "Running audio batch file with priority $transcodePriority: \"$audioBatchFile\"\n";
                    `"$audioBatchFile" > "$audioBatchFile.log"`;
                }
                else
                {
                    print "Audio file already exists\n";
                }
                print "<** Done\n\n";


                if ( -s "$audioFile" )
                {
                    print "Calculating exact audio size ";
                    $audioSize = -s "$audioFile";
                    $audioSize = ( $audioSize / 1024 );                                                # Convert to kb
                }
                else                                                                                   # Something went wrong
                {
                    updateStatusImage( "error", "Could not find $audioFile", @statusImageArray );
                }
            }
            else
            {
                # Estimate Audio Size based on video length
                print "\nEstimating audio size using $estAudioSize[$transcodeOrder[$videoIndex]] mb/minute ";
                $audioSize = $durations[ $transcodeOrder[$videoIndex] ] * (1024* $estAudioSize[ $transcodeOrder[$videoIndex] ]);
            }
            print " = $audioSize kb\n";

            # Check for custom scale otherwise use 512
            $xvidXRes     = 512;
            @customScales = ();
            if ( $customRes[ $transcodeOrder[$videoIndex] ] =~ /~/ )
            {
                @customScales = split( /~/, $customRes[ $transcodeOrder[$videoIndex] ] );
                foreach $rez (@customScales)
                {
                    if ( $rez =~ /::/ )
                    {
                        $origRes  = $`;
                        $scaleRes = $';
                        chomp($origRes);
                        chomp($scaleRes);
                        $regExExp = "x" . $origRes;
                        if ( $resolution[ $transcodeOrder[$videoIndex] ] =~ /$regExExp/ )
                        {
                            print "Custom Resolution found, $origRes = $resolution[$transcodeOrder[$videoIndex]]\n";
                            $xvidXRes = $scaleRes;
                            last;
                        }
                    }
                    elsif ($rez =~ /\d+/)
                    {   # Should be default
                        $xvidXRes = $rez;
                    }
                }
            }
            elsif ( $customRes[ $transcodeOrder[$videoIndex] ] =~ /\d+/ )
            {   # No commas should be default
                if ( $customRes[ $transcodeOrder[$videoIndex] ] =~ /::/ )
                {
                    $xvidXRes = $';
                }
                else
                {
                    $xvidXRes = $customRes[ $transcodeOrder[$videoIndex] ];
                }
            }
            print "Scaling to $xvidXRes\n";

            # Check for custom mb per 30 minutes, default 175
            $mbPerMin = 175/30;
            @customMbPer30Min   = ();
            if ( $mbPer30Min[ $transcodeOrder[$videoIndex] ] =~ /~/ )
            {
                @customMbPer30Min   = split( /~/, $mbPer30Min[ $transcodeOrder[$videoIndex] ] );
                foreach $mbPer30 (@customMbPer30Min)
                {
                    if ( $mbPer30 =~ /::/ )
                    {
                        $origRes  = $`;
                        $desiredMbPer30Min = $';
                        chomp($origRes);
                        chomp($desiredMbPer30Min);
                        $regExExp = "x" . $origRes;
                        if ( $resolution[ $transcodeOrder[$videoIndex] ] =~ /$regExExp/ )
                        {
                            print "Custom mb per 30 min found, $origRes = $resolution[$transcodeOrder[$videoIndex]]\n";
                            $mbPerMin = $desiredMbPer30Min/30;
                            last;
                        }
                    }
                    elsif (!($mbPer30 =~ />>/))
                    {   # Should be default
                        $mbPerMin = $mbPer30/30;
                    }
                }
            }
            elsif ( $mbPer30Min[ $transcodeOrder[$videoIndex] ] =~ /\d+/ )
            {
                if ( $mbPer30Min[ $transcodeOrder[$videoIndex] ] =~ /::/ )
                {
                    $mbPerMin = $'/30;
                }
                else
                {
                    $mbPerMin = $mbPer30Min[ $transcodeOrder[$videoIndex] ]/30;
                }
            }
            print "Using ".($mbPerMin*30)." mb per 30 min\n";

            # Check for custum video filters, default ""
            $custumVideoFilter    = "";
            @customVideoFilters   = ();
            if ( $videoFilters[ $transcodeOrder[$videoIndex] ] =~ /~/ )
            {
                @customVideoFilters   = split( /~/, $videoFilters[ $transcodeOrder[$videoIndex] ] );
                foreach $vfs (@customVideoFilters)
                {
                    if ( $vfs =~ /::/ )
                    {
                        $origRes  = $`;
                        $desiredVideoFilter = $';
                        chomp($origRes);
                        chomp($desiredVideoFilter);
                        $regExExp = "x" . $origRes;
                        if ( $resolution[ $transcodeOrder[$videoIndex] ] =~ /$regExExp/ )
                        {
                            print "Custum Video Filter found, $origRes = $resolution[$transcodeOrder[$videoIndex]]\n";
                            $custumVideoFilter = $desiredVideoFilter;
                            last;
                        }
                    }
                    else
                    {   # Should be default
                        $custumVideoFilter = $vfs;
                    }
                }
            }
            else
            {
                if ($videoFilters[ $transcodeOrder[$videoIndex] ] =~ /::/)
                {
                    $custumVideoFilter = $';
                }
                else
                {
                    $custumVideoFilter = $videoFilters[ $transcodeOrder[$videoIndex] ];
                }
            }
            print "Using video filter: $custumVideoFilter\n";

            # calculated desired video size
            if ( $hdtv[ $transcodeOrder[$videoIndex] ] == 1 &&
                 $cuttingComm[$transcodeOrder[$videoIndex]] == 1)
            {   # If it's HDTV, we need to add the comskip duration back in for the calculations
                $curVideoDur = $durations[ $transcodeOrder[$videoIndex] ] + $commDuration[$transcodeOrder[$videoIndex]];
            }
            else
            {
                $curVideoDur = $durations[ $transcodeOrder[$videoIndex] ];
            }

            $estVideoSize = ( ( $mbPerMin * 1024 ) * $curVideoDur ) - $audioSize;
            if ( $estVideoSize =~ /\./ )
            {
                $estVideoSize = $`;
            }
            print "Desired Video Size = $estVideoSize\n";

            $mencoderBitrate = ( $estVideoSize * 8 ) / ( $curVideoDur * 60 );
            if ( $mencoderBitrate =~ /\./ )
            {
                $mencoderBitrate = $`;
            }
            print "Mencoder bitrate = $mencoderBitrate\n\n";

            # Get Start Time
            ( $startSecond, $startMinute, $startHour, $dayOfMonth, $month, $yearOffset, $dayOfWeek, $dayOfYear, $daylightSavings ) = localtime();

            # Create transcoding batchfile
            print "*************  Creating transcoding batch file\n";
            $passNum = 1;

            if ($custumVideoFilter eq "")
            {   # Standard
                $vfString = "-vf scale$harddup -zoom -xy $xvidXRes";
            }
            else
            {   # Custom vf
                if ( !($custumVideoFilter =~ /scale/) )
                {
                    $scaleString = ",scale$harddup -zoom -xy $xvidXRes";
                }
                if ( !($custumVideoFilter =~ /-vf/) )
                {
                    $prefix = "-vf";
                }
                $vfString = "$prefix $custumVideoFilter$scaleString";
            }

            if ( !( $encOptsPassTwo[ $transcodeOrder[$videoIndex] ] =~ /none!/ ) )
            {   # First Pass
                if ($encOptsPassOne[$transcodeOrder[$videoIndex]] =~ /%input%/)
                {   # Override EVERYTHING
                    $mencoderBatch_1 = $encOptsPassOne[$transcodeOrder[$videoIndex]];
                    $mencoderBatch_1 =~ s/%input%/"$inputFile" $edlString/g;
                    if ( !($mencoderBatch_1 =~ /-o/) )
                    {   # Append -o NUL if not present
                        $mencoderBatch_1 = "$mencoderBatch_1 -o NUL";
                    }
                }
                else
                {
                    $mencoderOps_1 = "$edlString $vfString -nosound";
                    $mencoderBatch_1 = "\"$inputFile\" $mencoderOps_1 -ovc $encDefault[$transcodeOrder[$videoIndex]] $encOptsPassOne[$transcodeOrder[$videoIndex]] -o NUL";
                }
                print "Transcoding Video (Pass #$passNum): $mencoderBatch_1\n";
                $passNum++;
            }
            else
            {    # 1-pass encoding
                $encOptsPassTwo[ $transcodeOrder[$videoIndex] ] = $encOptsPassOne[ $transcodeOrder[$videoIndex] ];
            }

            # Second Pass
            if ( $encOptsPassTwo[$transcodeOrder[$videoIndex]] =~ /%input%/ &&
                 $encOptsPassTwo[$transcodeOrder[$videoIndex]] =~ /%output%/)
            {   # Override EVERYTHING
                $mencoderBatch_2 = $encOptsPassTwo[$transcodeOrder[$videoIndex]];
                $mencoderBatch_2 =~ s/%input%/"$inputFile" $edlString/g;
                $mencoderBatch_2 =~ s/%output%/"$outputFile"/g;
                $mencoderBatch_2 =~ s/%bitrate%/$mencoderBitrate/g;
            }
            else
            {
                $mencoderOps_2 = "$edlString $vfString";
                $mencoderBatch_2 = "\"$inputFile\" $mencoderOps_2 $audioOptions[$transcodeOrder[$videoIndex]] -ovc $encDefault[$transcodeOrder[$videoIndex]] $encOptsPassTwo[$transcodeOrder[$videoIndex]]$mencoderBitrate -o \"$outputFile\"";
            }
            print "Transcoding Video (Pass #$passNum): $mencoderBatch_2\n";

            unless ( open( BATFILE, ">$transPath[$transcodeOrder[$videoIndex]].bat" ) )
            {
                updateStatusImage( "error", "can't create transcode batch file $videoIndex", @statusImageArray );
            }
            print BATFILE "$sageDrive\n";
            print BATFILE "cd \"$sageDir\\perl2dvd\"\n";
            if ( !( $passNum == 1 ) )
            {
                print BATFILE "echo 1stPass > \"$transPath[$transcodeOrder[$videoIndex]].firstPass.working\"\n";
                print BATFILE "start /B /$transcodePriority /WAIT $mencoderEXE $mencoderBatch_1\n";
                print BATFILE "del \"$transPath[$transcodeOrder[$videoIndex]].firstPass.working\"\n";
            }
            print BATFILE "start /B /$transcodePriority /WAIT $mencoderEXE $mencoderBatch_2\n";
            close(BATFILE);
            if ( !( -e "$outputFile" ) )
            {
                print "Running video batch file with priority $transcodePriority: \"$transPath[$transcodeOrder[$videoIndex]].bat\"\n";
                `"$transPath[$transcodeOrder[$videoIndex]].bat" > "$transPath[$transcodeOrder[$videoIndex]].trans.log"`;
            }
            else
            {
                print "Compressed video already exists\n";
            }
            print "<** Done\n\n";

            if ( !( -s "$outputFile" ) )
            {
                updateStatusImage( "error", "Could not find $transFullPath[$transcodeOrder[$videoIndex]]", @statusImageArray );
            }

            if ( $hdtv[$transcodeOrder[$videoIndex]] == 1 &&
                 $cuttingComm[$transcodeOrder[$videoIndex]] == 1)
            {   # if HDTV, cut commercials after compress
                print "Editing out $commDuration[$transcodeOrder[$videoIndex]] minutes of commercials\n";
                $edlString = "-edl \"$fullFile[$transcodeOrder[$videoIndex]].edl\"";
                $cdDir     = "$sageDir\\perl2dvd";
                $cutBatchFile = "$transPath[$transcodeOrder[$videoIndex]].2cut.bat";
                $mencoderBatch = "$mencoderEXE \"$uncutFile\" $edlString -ovc copy -oac copy -o \"$transFullPath[$transcodeOrder[$videoIndex]]\"";
                print "Rinsing: $mencoderBatch\n";

                # Create transcoding batchfile
                print "*************  Creating commercial cutting batch file\n ";
                unless ( open( BATFILE, ">$cutBatchFile " ) )
                {
                    updateStatusImage( "error", "can't create commercial cutting batch file $videoIndex", @statusImageArray );
                }
                print BATFILE       "$sageDrive\n";
                print BATFILE       "cd \"$sageDir\\perl2dvd\"\n";
                print BATFILE       "start /B /$transcodePriority /WAIT $mencoderBatch\n";

                # Delete the uncut mpeg to save space
                if ($debugDelete == 0)
                {
                    print BATFILE   "del \"$uncutFile\"\n";
                }
                close(BATFILE);
                print "<** Done\n";

                if ( !( -e "$transFullPath[$transcodeOrder[$videoIndex]]" ) )
                {   # Only run batch file if .2cut file doesn't exist
                    print "Running cutting batch file with priority $transcodePriority: \"$cutBatchFile\"\n";
                    `"$cutBatchFile" > "$cutBatchFile.log"`;
                }
                else
                {
                    print "Cut video already exsists\n"
                }

            }

            # Get Finish Time
            ( $finishSecond, $finishMinute, $finishHour, $dayOfMonth, $month, $yearOffset, $dayOfWeek, $dayOfYear, $daylightSavings ) = localtime();

            # Print transcode stats
            $orignalFileSize    = -s "$inputFile";
            $orignalFileSize    = $orignalFileSize / 1024;                                                                                                                        # convert to kb
            $actualFileSize     = -s "$transFullPath[$transcodeOrder[$videoIndex]]";
            $actualFileSize     = $actualFileSize / 1024;                                                                                                                         # convert to kb
            $targetFileSize     = $mbPerMin  * 1024 * $durations[ $transcodeOrder[$videoIndex] ] + .0001;                               # plus .1 prevents divide by zero
            $percentError       = ( $actualFileSize / $targetFileSize ) * 100;
            $percentCompression = $actualFileSize / $orignalFileSize;
            $percentCompression *= 100;
            $percentCompression =~ /\./;
            $percentCompression = $`;

            # handle negative times
            if ( $finishSecond < $startSecond )
            {
                $finishSecond += 60;
                $finishMinute--;
            }
            if ( $finishMinute < $startMinute )
            {
                $finishMinute += 60;
                $finishHour--;
            }
            if ( $finishHour < $startHour )
            {
                $finishHour += 24;
            }

            $durHour = sprintf( "%02d", ( $finishHour - $startHour ) );
            $durMin  = sprintf( "%02d", ( $finishMinute - $startMinute ) );
            $durSec  = sprintf( "%02d", ( $finishSecond - $startSecond ) );
            $transcodeTime = $durHour . ":" . $durMin . ":" . $durSec;

            print "Mencoder Transcode Stats:\n";
            print "Profile[$transcodeOrder[$videoIndex]]             = $transProfile[$transcodeOrder[$videoIndex]]\n";
            print "Video Duration[$transcodeOrder[$videoIndex]]      = $durations[$transcodeOrder[$videoIndex]]\n";
            print "Original File Size[$transcodeOrder[$videoIndex]]  = $orignalFileSize\n";
            print "Actual File Size[$transcodeOrder[$videoIndex]]    = $actualFileSize\n";
            print "Target File Size[$transcodeOrder[$videoIndex]]    = $targetFileSize\n";
            print "Percent Error[$transcodeOrder[$videoIndex]]       = $percentError\n";
            print "Compression[$transcodeOrder[$videoIndex]]         = " . $percentCompression . "%\n";
            print "Total Trans Time[$transcodeOrder[$videoIndex]]    = $transcodeTime\n\n";

            if ( -e "$fullFile[$transcodeOrder[$videoIndex]].my" )
            {
                $foundCompLine = 0;
                open( MY, "$fullFile[$transcodeOrder[$videoIndex]].my" );
                while(<MY>)
                {
                    if ($_ =~ /compression/)
                    {
                        print "already has compression in .my file\n";
                        $foundCompLine = 1;
                        last;
                    }
                }
                close(MY);
                if ($foundCompLine == 0)
                {
                    print "Writting compression% to .my file\n";
                    open( MY, ">>$fullFile[$transcodeOrder[$videoIndex]].my" );
                    print MY "compression=" . $percentCompression . "%\n";
                    close(MY);
                }
            }

            if ($debugDelete == 0 && -s "$cleanMpeg")
            {
                $deleteString = "del $cleanMpeg";
                print "Deleting: $deleteString\n";
                `$deleteSting`;
            }

        }
    }
}

print "------------Transcoding Loop Finished ----------------\n";
close(QDVDFILE);
close(VIDEOMENU);

if ($numScreenShots > 0 && $targetFormat =~ /dvd/)
{
    #Getting screen shots
    print "Trying to get Screen shots\n";
    for ( $i = 0 ; $i < $numberOfVideos ; $i++ )
    {
        if ($cuttingComm[$i] == 1 || -s "$fullFile[$i].edlcut" || -s "$fullFile[$i].txtcut" ||
            !( $extention[$i] =~ /(mpg|ts|mpeg)/ && !(-s "$fullFile[$i].edl" || -s "$fullFile[$i].txt") ) )
        {   # We've cut the show and everything should be good or it is most likely an imported video
            $range = int(($durations[$i]*60)-60);
            $minimum = 30;
            $seed = rand($range) + 60 - $numScreenShots;
            for ($j = 0; $j < $numScreenShots; $j++)
            {
                if ($thumbnailEffect =~ /seq/)
                {
                    push(@startSeconds, int($seed));
                    $seed++;
                }
                else
                {
                    $time = int(rand($range)) + $minimum;
                    push(@startSeconds, int($seed));
                }
            }
        }
        elsif ( -s "$fullFile[$i].edl" )
        {   # Still has commercials, but we have a comskip file
            # Pick a random time between 30 and 4:30
            $range = 240;
            $minimum = 30;

            open(COMSKIP,"$fullFile[$i].edl");
            $line = <COMSKIP>;
            close(COMSKIP);

            $line =~ /\d*\.\d\d/;
            $firstNum = $&;
            $theRest  = $';
            $theRest =~ /\d*\.\d\d/;
            $secondNum = $&;

            # After commercial
            $comMark = $secondNum;
            $comMark =~ /\./;
            $seconds = $`;

            $seed = rand($range) + 60 - $numScreenShots;
            for ($j = 0; $j < $numScreenShots; $j++)
            {
                if ($thumbnailEffect =~ /seq/)
                {
                    push(@startSeconds, int($seed));
                    $seed++;
                }
                else
                {
                    $time = int(rand($range)) + $minimum + $seconds;
                    while ($durations[$i] < ($time/60))
                    {    #Check to make sure its within the duration
                        $time -= 30;
                    }
                    push(@startSeconds, $time);
                }
            }

        }
        else
        {   # No comskip and no cuts, just aim and prey
            $range = $durations[$i];
            $range =~ /\./;
            $range = $`;
            $minimum = 300;
            $seed = rand($range) + $minimum - $numScreenShots;
            for ($j = 0; $j < $numScreenShots; $j++)
            {
                if ($thumbnailEffect =~ /seq/)
                {
                    push(@startSeconds, int($seed));
                    $seed++;
                }
                else
                {
                    push(@startSeconds, int(rand($range)) + $minimum);
                }
            }
        }

        $pic = 0;
        foreach $ss (@startSeconds)
        {
            if ($thumbnailEffect =~ /seq/)
            {
                $multiSSFilename = "$transPath[$i].$pic.s.jpg";
            }
            else
            {
                $multiSSFilename = "$transPath[$i].$pic.jpg";
            }

            if ($numScreenShots == 1)
            {
                $ffmpegString = "\"$sageTVTranscoder\" -ss $ss -y -i \"$transFullPath[$i]\" -f mjpeg -vframes 1 -deinterlace -an \"$transPath[$i].jpg\"";
            }
            else
            {
                $ffmpegString = "\"$sageTVTranscoder\" -ss $ss -y -i \"$transFullPath[$i]\" -f mjpeg -vframes 1 -deinterlace -an \"$multiSSFilename\"";
            }
            print "Getting Screenshot: $ffmpegString\n";
            `$ffmpegString`;
            if ($numScreenShots > 1 && (-s "$transPath[$i].$pic.jpg" || -s "$transPath[$i].$pic.s.jpg") )
            {
                $pic++;
            }
        }

        $screenShot[$i] = "";
        if (-s "$transPath[$i].jpg"  || -s "$transPath[$i].0.jpg" || -s "$transPath[$i].0.s.jpg")
        {
            print "Adding Screenshot[$i]: $transPath[$i].jpg\n";
            $screenShot[$i] = "$transPath[$i].jpg";
        }
        else
        {
            print "Screenshot[$i] doesn't exist\n";
        }
        @startSeconds = ();
    }
}


if ( $targetFormat =~ /dvd/ )
{
    print "\n------------ Generating Menu ----------------\n";
    $themeFolder = "$sageDir\\STVs\\SageTV3\\SageMCE";

    if ( $theme =~ /random/ )
    {
        print "Getting Random Theme...\n";
        unless ( opendir( THEMES, "$themeFolder" ) )
        {
            updateStatusImage( "error", "Couldn't open $themeFolder for random theme", @statusImageArray );
        }

        while ( $name = readdir(THEMES) )
        {
            if ( -d "$themeFolder\\$name" )
            {
                if ( -e "$themeFolder\\$name\\menuGen.override" )
                {
                    print "$name\n";
                    push( @randomThemes, $name );
                }
            }
        }
        closedir(SCRATCH);
        if ( @randomThemes == 0 )
        {
            updateStatusImage( "error", "Failed to pick random theme.  Do any of your folders contain menuGen.override files?", @statusImageArray );
        }
        $theme = $randomThemes[ rand(@randomThemes) ];
        print "Random Theme = $theme\n";
    }

    # Clean out trouble charactors
    for ( $i = 0 ; $i < $numberOfVideos ; $i++ )
    {
        $showTitle[$i]   =~ s#$illCharMenuRegEx##g;
        $episodeDesc[$i] =~ s#$illCharMenuRegEx##g;
        $episodeName[$i] =~ s#$illCharMenuRegEx##g;
    }

    # Creating menuGen.bat
    unless ( open( BATFILE, ">$scratchPath[0]\\menuGen.bat" ) )
    {
        updateStatusImage( "error", "Couldn't create menuGen.bat file", @statusImageArray );
    }
    print BATFILE "$sageDrive\n";
    print BATFILE "cd \"$sageDir\"\n";

    #echo gen file
    print BATFILE "echo Theme Folder =$themeFolder\\$theme> menuGen.gen\n";
    print BATFILE "echo Work Folder =$scratchPath[0]>> menuGen.gen\n";
    print BATFILE "echo Graphics Magick =$gm>> menuGen.gen\n";
    print BATFILE "echo Mplex =$mplex>> menuGen.gen\n";
    print BATFILE "echo png2yuv =$png2yuv>> menuGen.gen\n";
    print BATFILE "echo mpeg2enc =$mpeg2enc>> menuGen.gen\n";
    print BATFILE "echo spumux =$spumux>> menuGen.gen\n";
    print BATFILE "echo AC3 audio =$sageDir\\perl2DVD\\Silence.ac3>> menuGen.gen\n";
    print BATFILE "echo Button Image =$sageDir\\perl2DVD\\navButton.png>> menuGen.gen\n";
    print BATFILE "echo DVD Format (PAL or NTSC) =$dvdRes>> menuGen.gen\n";
    print BATFILE "echo Leave files for debugging (0 is false, 1 is true)=$debugDelete >> menuGen.gen\n";

    for ( $i = 0 ; $i < $numberOfVideos ; $i++ )
    {
        print BATFILE "echo ---------------Video $i--------------------- >> menuGen.gen\n";
        print BATFILE "echo Video $i Show Title =$showTitle[$i] >> menuGen.gen\n";
        print BATFILE "echo Video $i Episode Title =$episodeName[$i] >> menuGen.gen\n";
        print BATFILE "echo Video $i Description = $episodeDesc[$i] >> menuGen.gen\n";
        print BATFILE "echo Video $i Thumbnail =$screenShot[$i] >> menuGen.gen\n";
    }
    print BATFILE "menuGen.exe\n";
    close(BATFILE);
    print "<** Done\n";
    print "Running menuGen batch file: \"$scratchPath[0]\\menuGen.bat\"\n";
    `"$scratchPath[0]\\menuGen.bat"`;

    unless ( -e "$scratchPath[0]\\menuBackground.menu.mpg" )
    {
        updateStatusImage( "error", "Could not find $scratchPath[0]\\menuBackground.menu.mpg", @statusImageArray );
    }

    # Create Video_TS folder with dvdauthor

    if ( -e "$scratchPathIMG\\$qdvdFile.imgFolder" )
    {
        `rd /S /Q "$scratchPathIMG\\$qdvdFile.imgFolder\"`;
    }
    print "\n------------ Creating DVD file Stucture ----------------\n";
    `mkdir "$scratchPathIMG\\$qdvdFile.imgFolder"`;
    unless ( open( XMLCONFIG, ">$scratchPath[0]\\$qdvdFile.config.xml" ) )
    {
        updateStatusImage( "error", "can't open config.xml", @statusImageArray );
    }
    print XMLCONFIG "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n";
    print XMLCONFIG "<dvdauthor dest=\"$scratchPathIMG\\$qdvdFile.imgFolder\">\n";
    print XMLCONFIG "<!-- DO NOT edit the 2 lines above -->\n";
    print XMLCONFIG "  <vmgm>\n";
    print XMLCONFIG "    <menus>\n";
    print XMLCONFIG "      <video format=\"$regionalFormat\" aspect=\"4:3\" widescreen=\"noletterbox\"/>\n";
    print XMLCONFIG "      <pgc>\n";

    for ( $i = 0 ; $i < $numberOfVideos ; $i++ )
    {
        print XMLCONFIG "        <button> jump titleset " . ( $i + 1 ) . " menu; </button>\n";
        print XMLCONFIG "        <vob file=\"$scratchPath[0]\\menuBackground.menu.mpg\" pause=\"5\"/>\n";
    }
    print XMLCONFIG "      </pgc>\n";
    print XMLCONFIG "    </menus>\n";
    print XMLCONFIG "  </vmgm>\n";
    for ( $i = 0 ; $i < $numberOfVideos ; $i++ )
    {
        print XMLCONFIG "  <titleset>\n";
        print XMLCONFIG "    <menus>\n";
        print XMLCONFIG "      <video format=\"$regionalFormat\" aspect=\"$aspectRatio[$i]\" widescreen=\"$widescreen[$i]\"/>\n";
        print XMLCONFIG "      <pgc>\n";
        print XMLCONFIG "        <button> jump title 1; </button>\n";
        print XMLCONFIG "        <button> jump vmgm menu; </button>\n";
        print XMLCONFIG "        <vob file=\"$scratchPath[0]\\subMenuBackground.$i.menu.mpg\" pause=\"5\"/>\n";
        print XMLCONFIG "        <post>jump cell 1;</post>\n";
        print XMLCONFIG "      </pgc>\n";
        print XMLCONFIG "    </menus>\n";
        print XMLCONFIG "    <titles>\n";
        print XMLCONFIG "      <video format=\"$regionalFormat\" aspect=\"$aspectRatio[$i]\" widescreen=\"$widescreen[$i]\"/>\n";
        print XMLCONFIG "      <pgc>\n";
        print XMLCONFIG "        <vob file=\"$scratchPath[$i]\\$file[$i].2dvd.mpg\" chapters=\"$chapters[$i]\" />\n";
        print XMLCONFIG "        <post>call vmgm menu;</post>\n";
        print XMLCONFIG "      </pgc>\n";
        print XMLCONFIG "    </titles>\n";
        print XMLCONFIG "  </titleset>\n";
    }
    print XMLCONFIG "</dvdauthor>\n";
    close(XMLCONFIG);

    $dvdAuthorString = "\"$dvdAuthor\" -x \"$scratchPath[0]\\$qdvdFile.config.xml\"";
    $dvdAuthorString =~ s#\\\\#\\\\\\\\#g;
    print "Creating DVD File Structure: $dvdAuthorString\n";
    `$dvdAuthorString 2> "$scratchPath[0]\\$qdvdFile.dvdauthor.log"`;
    print "<** Done\n";
}
elsif ( $targetFormat =~ /xvid/ )
{
    print "\n------------ Preping files to be burned to DVD ----------------\n";
    if ( -e "$scratchPathIMG\\$qdvdFile.imgFolder" )
    {
        `rd /S /Q "$scratchPathIMG\\$qdvdFile.imgFolder\"`;
    }
    `mkdir "$scratchPathIMG\\$qdvdFile.imgFolder"`;
    for ( $i = 0 ; $i < $numberOfVideos ; $i++ )
    {
        $copyString = "copy \"$transFullPath[$i]\" \"$scratchPathIMG\\$qdvdFile.imgFolder\\$videoImportName[$i]\"";
        print "Copying: $copyString\n";
        `$copyString`;
        foreach $ext (@extsToSave)
        {
            print "Checking for .$ext... ";
            if ( -e "$fullPath[$i].$ext" )
            {
                $copyString = "copy \"$fullPath[$i].$ext\" \"$scratchPathIMG\\$qdvdFile.imgFolder\\$videoImportName[$i].$ext\"";
                print " Copying: $copyString\n";
                `$copyString`;
            }
            elsif ( -e "$fullFile[$i].$ext" )
            {
                $copyString = "copy \"$fullFile[$i].$ext\" \"$scratchPathIMG\\$qdvdFile.imgFolder\\$videoImportFile[$i].$ext\"";
                print " Copying: $copyString\n";
                `$copyString"`;
            }
            else
            {
                print "\n";
            }
        }
    }
}

# Create ISO
# Putting it back in play just in case I can't do any better
if ( $targetFormat =~ /(xvid|dvd)/ )
{
    print "\n------------ Creating Burnable image ----------------\n";
        $mkisofsString = "\"$mkisofs\"  -dvd-video -o \"$scratchPathIMG$qdvdFile.img\" \"$scratchPathIMG$qdvdFile.imgFolder\"";
        $mkisofsString =~ s#\\\\#\\\\\\\\#g;
        print "Creating Burnable Image: $mkisofsString\n";
        `$mkisofsString`;
        $imgSize = (-s "$scratchPathIMG\\$qdvdFile.img")/1024;

        if ($changeImgPermissions == 1)
        {
            $changePermissionsString = "echo Y| cacls \"$scratchPathIMG$qdvdFile.img\" /G everyone:F /C";
            print "Change permissions of image: $changePermissionsString\n";
            `$changePermissionsString`;
        }
    print "<** Done\n";
}

#Translate path to UNC if required
$pathToImg = $scratchPathIMG;
if ( $uncWorkFolder =~ /\\\\/ )
{
    if ($uncWorkFolder =~ /,/)
    {
        print "Real Path: $scratchPathIMG\n";
        foreach $path (@fullToUNCIMG)
        {
            chomp($path);
            $path =~ /::/;
            $UNC  = $';
            $FULL = $`;
            chomp($UNC);
            chomp($FULL);
            print "Replace: $FULL\n";
            if ( $scratchPathIMG eq $FULL)
            {
                $pathToImg = $UNC;
                print "Translating IMG Path to UNC: $pathToImg\n";
            }
        }
    }
}

if (!($showFinished == 0 && $targetFormat =~ /vidLib/))
{
    if ($compressMode == 0)
    {
        # Delete status image to make room for the real one
        $delString = "del \"$sageOthers\\$qdvdFile.burn_i.lnk\"";
        print "Deleting fake shortcut: $delString\n";
        `$delString`;

        $delString = "del \"$sageOthers\\$qdvdFile.burn_i.jpg\"";
        print "Deleting status image: $delString\n";
        `$delString`;


        # Create buring batchfile
        print "\n------------ Creating buring batch file ----------------\n";
        unless(open(BATFILE,">$sageOthers\\$qdvdFile.burn.bat"))
        {
            updateStatusImage("error","Can't Create batch file at $sageOthers\\$qdvdFile.burn.bat",@statusImageArray);
        }
        if ( !( $targetFormat =~ /vidLib/ ) )
        {    # IF we are burnig a DVD
                print BATFILE "\"$imgBurn\" /MODE ISOWRITE /SRC \"$pathToImg\\$qdvdFile.img\"  /DEST \"$burnerDrive\" $imgBurnSwitches\n";
                print BATFILE "PING 1.1.1.1 -n 1 -w 1000 >NUL\n";
                print BATFILE "if exist \"$pathToImg\\$qdvdFile.img\" goto end\n";
        }
        print BATFILE "echo done > \"$localSageOthers\\$qdvdFile.burn.done\"\n";
        print BATFILE "del \"$localSageOthers\\$qdvdFile.burn$otherProgramsExt.lnk\"\n"; # delete link so you can't burn a second time
        print BATFILE "del \"$localSageOthers\\$qdvdFile.burn$otherProgramsExt.jpg\"\n";
        print BATFILE "del \"$localSageOthers\\$qdvdFile.autoburn.bat\"\n";

        print BATFILE "goto end\n";
        print BATFILE ":end\n";
        if (!($sageReWake eq ""))
        {
            print BATFILE "\"$sageReWake\" -awake\n"; # Wake sage up
        }
        close(BATFILE);
        print "<** Done\n";
    }
}

# Still need to figure out a way to do this
#if ($compressMode == 0)
#{
#    if ($enableStatus == 1)
#    {
#       # Delete status image to make room for the real one
#       $delString = "del \"$sageOthers\\$qdvdFile.burn_i.lnk\"";
#       print "Deleting fake shortcut: $delString\n";
#       `$delString`;
#
#       $delString = "del \"$sageOthers\\$qdvdFile.burn_i.jpg\"";
#       print "Deleting status image: $delString\n";
#      `$delString`;
#    }
#
#    # Create buring batchfile
#    print "\n------------ Creating buring batch file ----------------\n";
#    unless ( open( BATFILE, ">$sageOthers\\$qdvdFile.burn.bat" ) )
#    {
#        updateStatusImage( "error", "Can't Create batch file at $sageOthers\\$qdvdFile.burn.bat", @statusImageArray );
#    }
#    if ( !( $targetFormat =~ /vidLib/ ) )
#    {    # IF we are burnig a DVD
#            # Make label for DVD
#        $qdvdFile =~ /(\.xvidList|\.dvdList)/;
#        $vLabel = $`;
#        $vLabel = "\U$vLabel";
#        print "Using Volume Label = $vLabel\n";
#
#        print BATFILE "\"$imgBurn\" /MODE ISOBUILD /BUILDMODE DEVICE /FILESYSTEM \"ISO9660 + UDF\" /VOLUMELABEL \"$vLabel\" /SRC \"$pathToImg\\$qdvdFile.imgFolder\"  /DEST \"$burnerDrive\" /LOG \"$localSageOthers\\$qdvdFile.burnlog\" $imgBurnSwitches\n";
#        if ( $imgBurnErrorDetect == 1 )
#        {
#            print BATFILE "if NOT errorlevel 0 goto end\n";
#        }
#        elsif ( $imgBurnErrorDetect == 2 )
#        {
#            print BATFILE "PING 1.1.1.1 -n 1 -w 1000 >NUL\n";
#            print BATFILE "if exist \"$pathToImg\\$qdvdFile.img\" goto end\n";
#        }
#        elsif ( $imgBurnErrorDetect == 3 )
#        {
#
#            # Write a script that parses the log to deterimine if the log was a success and somehow pass that info back to the script
#        }
#    }
#    print BATFILE "echo done > \"$localSageOthers\\$qdvdFile.burn.done\"\n";
#    print BATFILE "del \"$localSageOthers\\$qdvdFile.burn$otherProgramsExt.lnk\"\n";    # delete link so you can't burn a second time
#    print BATFILE "del \"$localSageOthers\\$qdvdFile.burn$otherProgramsExt.jpg\"\n";
#    print BATFILE "del \"$localSageOthers\\$qdvdFile.autoburn.bat\"\n";
#
#    print BATFILE "goto end\n";
#    print BATFILE ":end\n";
#    if ( !( $sageReWake eq "" ) )
#    {
#        print BATFILE "\"$sageReWake\" -awake\n";                                       # Wake sage up
#    }
#    close(BATFILE);
#    print "<** Done\n";
#}

# In-place copy compressed movies
if ( ($inPlaceAndDVD == 1 && $targetFormat =~ /xvid/) || $targetFormat =~ /vidLib/ )
{
    print "\n------------ Moving Files to video import folder ----------------\n";
    for ( $i = 0 ; $i < $numberOfVideos ; $i++ )
    {
        if ($extention[$i] =~ /(mpg|mpeg|ts)/ ||
            $cuttingComm[$i] == 1 )
        {   # Only if the original was an mpg
            print "Moving $transFullPath[$i] to $fullFile[$i].$container[$i]\n";
            # Touch
            $touchString = "\"$touch\" -r \"$fullPath[$i]\" \"$transFullPath[$i]\"";
            print "Touching: $touchString\n";
            `$touchString`;

            $compFile = "$transFullPath[$i]";

            # If we're working in a centralized work folder, we need to copy over a tmp file first
            if ( !($centralWorkFolder eq "") )
            {
                print "Creating tmp file $fullFile[$i].tmp\n";
                # moving
                $to = "$fullFile[$i].tmp";
                $from = "$transFullPath[$i]";
                $moveString = "echo y | move \"$from\" \"$to\"";
                print "Moving: $moveString\n";
                `$moveString`;
                $compFile = $to;
            }

            # Delete original
            if ( ( $autoDeleteXvidDVD == 1 && $targetFormat =~ /xvid/ ) || ( $autoDeleteVidLib == 1 && $targetFormat =~ /vidLib/ ) )
            {
                $delString = "del \"$fullPath[$i]\"";
                print "Deleting: $delString\n";
                `$delString`;
            }
            #Copying
            $to         = "$fullFile[$i].$container[$i]";
            $from       = "$compFile";
            $moveString = "echo y | move \"$from\" \"$to\"";
            print "moving: $moveString\n";
            `$moveString`;

            print "Creating $fullFile[$i].compressed\n";
            open( COMP, ">$fullFile[$i].compressed" );
            print COMP "Compressed!\n";
            close(COMP);
        }
    }
    print "<** Done\n";
}

# Create shortcut
if (!($showFinished == 0 && $targetFormat =~ /vidLib/))
{
    if ($compressMode == 0)
    {
        print "\n------------ Creating Shortcut ----------------\n";
        $link = new Win32::Shortcut();
        $link->Path("$localSageOthers\\$qdvdFile.burn.bat");
        $link->WorkingDirectory($localSageOthers);
        $link->Save("$scratchPath[0]\\$qdvdFile.burn.lnk");
        $link->Close();

        $copyString = "copy \"$scratchPath[0]\\$qdvdFile.burn.lnk\" \"$sageOthers\\$qdvdFile.burn$otherProgramsExt.lnk\"";
        print "Copying burning batch file: $copyString\n";
        `$copyString`;
        print "<** Done\n";
    }

    # Copy the burn image to the Other Programs Folder
    if ( !( $targetFormat =~ /vidLib/ ) && $compressMode == 0)
    {
        $gmString = "\"$gm\" composite -resize 150x150 \"$sageDir\\perl2DVD\\finished.png\" \"$burnImage\" \"$sageOthers\\$qdvdFile.burn$otherProgramsExt.jpg\"";
    }
    else
    {
        $gmString = "\"$gm\" composite -resize 150x150 \"$sageDir\\perl2DVD\\vidLib.png\" \"$burnImage\" \"$sageOthers\\$qdvdFile.burn$otherProgramsExt.jpg\"";
    }
    print "Executing- $gmString\n";
    `$gmString`;
}
else
{
    # Delete status images
    $delString = "del \"$sageOthers\\$qdvdFile.burn_i.lnk\"";
    print "Deleting fake shortcut: $delString\n";
    `$delString`;

    $delString = "del \"$sageOthers\\$qdvdFile.burn_i.jpg\"";
    print "Deleting status image: $delString\n";
    `$delString`;
}


print "\n------------ Safty Check and Cleanup ----------------\n";
for ( $i = 0 ; $i < $numberOfVideos ; $i++ )
{
    $numDir       = 0;
    $foundQdvdDir = 0;
    unless ( opendir( SCRATCH, "$scratchPath[$i]" ) )
    {
        updateStatusImage( "error", "Couldn't open scratch directory", @statusImageArray );
    }
    while ( $name = readdir(SCRATCH) )
    {
        if ( -d "$scratchPath[$i]\\$name" )
        {
            unless ( $name =~ /\Q$qdvdFile\E/ )
            {
                $numDir++;
            }
        }
    }
    closedir(SCRATCH);

    print "Number of extra dirs found in $scratchPath[$i] = $numDir\n";
    if ( ( $numDir != 2 ) )
    {
        updateStatusImage( "error", "Unexpected number of extra directorys in $scratchPath[$i]", @statusImageArray );
    }
}

# If we cut commercials we'll probably want to rename the comskip files
# That way, if they go to burn the compressed shows to DVD we can use the
# can still use the comskip files for commercials but the STV will ignore
# them
if ( $targetFormat =~ /(xvid|vidLib)/)
{
    print "Moving comskip files to cut files\n";
    for ( $i = 0 ; $i < $numberOfVideos ; $i++ )
    {
        if ( $cuttingComm[$i] == 1 )
        {
            if ( -e "$fullFile[$i].edl" )
            {
                $moveString = "move \"$fullFile[$i].edl\" \"$fullFile[$i].edlcut\"";
                print "Moving: $moveString\n";
                `$moveString`;
            }
            if ( -e "$fullFile[$i].txt" )
            {
                $moveString = "move \"$fullFile[$i].txt\" \"$fullFile[$i].txtcut\"";
                print "Moving: $moveString\n";
                `$moveString`;
            }
        }
    }
}

if ( $saveLogFile != 1 )
{
    print "del \"$logFile\"\n";
    `del "$logFile"`;
}

if ( $debugDelete == 0 )
{
    if ($compressMode == 0)
    {
        print "del \"$qdvdFullPath\"\n";
        `del "$qdvdFullPath"`;
    }
    print "del \"$qdvdFullFile.work\"\n";
    `del "$qdvdFullFile.work"`;

    if (-e "$scratchPathIMG\\$qdvdFile.imgFolder")
    {
        print "rd /S /Q \"$scratchPathIMG\\$qdvdFile.imgFolder\"\n";
        `rd /S /Q "$scratchPathIMG\\$qdvdFile.imgFolder\"`;
    }

    for ( $i = 0 ; $i < $numberOfVideos ; $i++ )
    {
        if (-e "$scratchPath[$i]")
        {
            print "rd /S /Q \"$scratchPath[$i]\"\n";
            `rd /S /Q "$scratchPath[$i]\"`;
        }
    }
}
print "<** Done\n";

close(LOGFILE);

# DONE!

sub runCommand
{
    my ( $command, $action ) = @_;
    print "$action: $command\n";
    `$command`;
}

sub nOrderEQ
{
    my ( $X, @coefs ) = @_;
    my ($result) = 0;
    my ($n)      = 0;
    my ($length) = scalar @coefs;
    print "Result = ";
    for ( $n = 0 ; $n < $length ; $n++ )
    {
        $power = $length - $n - 1;
        print "$coefs[$n]*$X^$power";
        if ( $n != ( $length - 1 ) )
        {
            print " + ";
        }
        $result += $coefs[$n] * ( $X**$power );
    }
    print " = $result\n";
    return $result;
}

sub updateStatusImage
{
    my ( $status, $errorMsg, $otherProgramsBase, $backgroundImage, $gmExe, $perl2dvdFolder, $enableStatus, $localOtherProgramsBase, $localBase, $reWake ) = @_;

    if ( $status =~ /error/ )
    {
        if ( $enableStatus != 0 )
        {

            # Delete status image to make room for the real one
            $delString = "del \"" . $otherProgramsBase . "_i.lnk\"";
            print "Deleting fake shortcut: $delString\n";
            `$delString`;

            $delString = "del \"" . $otherProgramsBase . "_i.jpg\"";
            print "Deleting status image: $delString\n";
            `$delString`;

            print "\n------------ Creating error batch file ----------------\n";
            unless ( open( BATFILE, ">$otherProgramsBase.bat" ) )
            {
                print "Can't Create batch file at $otherProgramsBase.bat\n";
                die "can't create batch file";
            }
            print BATFILE "echo done > \"$localOtherProgramsBase.done\"\n";
            print BATFILE "del \"$localOtherProgramsBase.lnk\"\n";    # delete link
            print BATFILE "del \"$localOtherProgramsBase.jpg\"\n";
            if ( !( $reWake eq "" ) )
            {
                print BATFILE "\"$reWake\" -awake\n";                 # Wake sage up
            }
            close(BATFILE);
            print "<** Done\n";

            # Create error cleanup shortcut
            $newLink = new Win32::Shortcut();
            $newLink->Path("$localOtherProgramsBase.bat");
            $newLink->WorkingDirectory("$localBase");
            $newLink->Save("$otherProgramsBase.lnk");
            $newLink->Close();

            # Create errored status image
            $gmString = "\"$gmExe\" composite -resize 150x150 \"$perl2dvdFolder\\$status.png\" \"$backgroundImage\" \"$otherProgramsBase.jpg\"";
            print "Executing- $gmString\n";
            `$gmString`;
        }

        print "** ERROR **\n";
        print "$errorMsg\n";
        die $errorMsg;
    }
    elsif ( $enableStatus != 0 )
    {
        $gmString = "\"$gmExe\" composite -resize 150x150 \"$perl2dvdFolder\\$status.png\" \"$backgroundImage\" \"" . $otherProgramsBase . "_i.jpg\"";
        print "Executing- $gmString\n";
        `$gmString`;

        #Create possibly aimless shortcut
        $newLink = new Win32::Shortcut();
        $newLink->Path("C:\\nowhere.bat");
        $newLink->WorkingDirectory("C:\\");
        $newLink->Save( $otherProgramsBase . "_i.lnk" );
        $newLink->Close();
    }
}

